unit uChars;

interface

procedure LoadKid;
procedure SaveKid;
procedure SetKidInitial;
procedure LoadShad(idx: integer);
procedure SaveShad(idx: integer);
procedure LoadShadAsOpp(idx: integer);
procedure SaveOppAsShad(idx: integer);
procedure SetShadInitial;
procedure JumpSeq(seq: word);
procedure ComputeCharY;
procedure ComputeCharYOnLowered;
function AddCharX(delta: smallint): smallint;
function AddFCharX(delta: smallint): smallint;
procedure AnimChar;
procedure SetupKid;
procedure SetupChar;
procedure GetCharEdges;
procedure IndexChar;
procedure ClipChar;
procedure AddCharObj(chartype: word);
procedure MakeFCharClipRect;
procedure Opponent1;
procedure DefineCharPos;
procedure SetupSword(swordtype: word);
procedure SetupFlask;
procedure SetupOpponent;
function GetBaseX: smallint;
function GetDist:smallint;
function GetDist1(x: smallint): smallint;
function GetCharCol(x: smallint): smallint;


implementation
  uses uGlobals, uMacFile, uResources, uSwapper, uFrames, uShapelist, uMacTypes, uRect,
  uCellUtil, uObj, uShapeSets, uPop2Types, uCharBanks, uOpponents, uFLames;

  const
  CharTypes: array [0..10] of word = ( $2, $A, $4, $6, $1, $7, $8, $2, $B, $C, $0);

  var

  templeft1, templeft2, tempright1, tempright2: smallint;
  temptop, tempbottom: smallint;
  tempwidth, tempheight: smallint;


procedure LoadKid;
begin
  ActiveChar := Kid;
end;

procedure SaveKid;
begin
  Kid := ActiveChar;
end;

procedure SetKidInitial;
var
steps: word;
seq: smallint;
  ctr: Integer;
begin
  //deux kids au niveau 7! (deux entres)
  if currentlevel.LevelNumber = 7 then
  begin
    if currentroom = 4 then
    begin
      currentlevel.InitialRoom := 4;
      currentlevel.InitialCell := 25;
    end
    else if currentroom = 32 then
    begin
      currentlevel.InitialRoom := 32;
      currentlevel.InitialCell := 24;
    end;
  end;
  if currentroom <> currentlevel.InitialRoom then exit;
  Kid.BlockX := currentlevel.InitialCell mod 10;
  Kid.BlockY := currentlevel.InitialCell div 10;
  Kid.Face := not currentlevel.InitialFacing;
  Kid.X := $E5 + Kid.BlockX * 51;


  LoadKid;
  seq := -1;
  steps := 0;
  if (currentlevel.leveltype = 5) and (currentlevel.initialroom = 4) then
  begin
    dec(ActiveChar.X, 8);
    steps := 9;
    seq := 4;
  end
  else if (currentlevel.leveltype = 1) then
    seq := $7C
  else if (currentlevel.initialroom = $1B) and (CurrentLevel.LevelNumber=6) then
  begin
    ActiveChar.X := 374;
    seq := 2;
  end
  else if (currentlevel.initialroom = $16) and (currentlevel.levelnumber = 10) then
  begin
    ActiveChar.X := 430;
    seq := 2;
  end
  else if (currentlevel.levelnumber = 14) and (currentlevel.initialroom = 1) then
  begin
    ActiveChar.X := 498;
    seq := 2;
  end
  else
    seq := 5;

  JumpSeq(seq);
  for ctr := 0 to steps - 1 do
    AnimChar;

  ActiveChar.Index := 10;
  ActiveChar.ColorOffset := 0;
  ActiveChar.CharType := 0;
  ActiveChar.Sword := 0;
  ActiveChar.Status := 0;
  ActiveChar.Death := -1;
  ComputeCharY;

  AnimChar;

  SaveKid;

end;

procedure LoadShad(idx: integer);
begin
  ActiveChar := Shads[idx];
end;

procedure SaveShad(idx: integer);
begin
  Shads[idx] := ActiveChar;
end;

procedure LoadShadAsOpp(idx: integer);
begin
  ActiveOpp := Shads[idx];
end;

procedure SaveOppAsShad(idx: integer);
begin
  Shads[idx] := ActiveOpp;
end;

procedure SetShadInitial;
var
  ctr: Integer;
  cell: word;
  theguard: PStaticGuard;
begin
  if currentroom = 0 then exit;

  CheckSideRoomsForVisibleOpps;

  for ctr := 0 to currentlevel.RoomGuards[currentroom -1].Count - 1 do
  begin
    theguard := @currentlevel.RoomGuards[currentroom - 1].Guards[ctr];
    ActiveChar.CharType := CharTypes[theguard^.GuardType];
    //CHeckLoadedOppSet(currentlevel.RoomGuards[currentroom - 1].Guards[ctr].GuardType);
    ActiveChar.Index := ctr;
    ActiveChar.Room := currentroom;
    cell := theguard^.Cell;
    ActiveChar.BlockY := cell div 10;
    if ActiveChar.BlockY < 0 then
      dec(ActiveChar.BlockY);

    if (ActiveChar.CharType = 2) and (theguard^.Seq = 100) then
      ActiveChar.Y := theguard^.m_1C
    else if (ActiveChar.CharType = 6) and (theguard^.m_22 <> 0) then
      ActiveChar.Y := theguard^.m_22
    else
      ComputeCharY;

    ActiveChar.X := theguard^.Left;
    ActiveChar.BlockX := GetCol(ActiveChar.X - 22);
    ActiveChar.Face := theguard^.Face;
    SetCharacterBank(theguard^.m_C);
    if theguard^.SeqPos = 0 then
    begin
      //quelques AddOpponents...
      if ActiveChar.CharType = 4 then
        theguard := SkelAddOpponent(theguard)
      else if ActiveChar.CharType in [7,8,$B] then
        theguard := HeadAddOpponent(theguard)
      else if ActiveChar.CharType = 10 then
      begin
        if IsFloor(ReadCell(ActiveChar.Room, ActiveChar.BlockX, ActiveChar.BlockY)) then
        begin
          theguard^.Seq :=  105;
          ActiveChar.Sword := 0;
        end
        else
        begin
          theguard^.Seq :=  106;
          ActiveChar.Sword := 1;
          if ActiveChar.X < Kid.X then
            ActiveChar.Face := 0
          else
            ActiveChar.Face := -1;
        end;
      end
      else if ActiveChar.CharType = 6 then
      begin
        if theguard^.Seq <> 197 then
          theguard^.Seq := 2
        //else
          //AddSound(261);
      end
      else
      begin
        if theguard^.Seq <> 22 then
          theguard^.Seq := 77;
        ActiveChar.Sword := 0;
      end;
      JumpSeq(theguard^.Seq);
    end
    else
    begin
      ActiveChar.SeqID := theguard^.Seq;
      ActiveChar.SeqPos := theguard^.SeqPos;
      ActiveChar.Sword := theguard^.Sword;
    end;
    
   AnimChar;

   if ActiveChar.CharType in [7,8] then
     ActiveChar.Action := 0
   else
     ActiveChar.Action := 1;

    SaveShad(ctr);
  end;

  if currentlevel.RoomGuards[currentroom -1].Count > 0 then
  begin
    if (currentlevel.levelnumber = 12) and (currentroom in [7,$B,$13]) and (currentopptype<>1) then
      LoadOppSet(1)
    else
    begin
      if (currentopptype <> currentlevel.opponenttype) and (currentlevel.opponenttype <> 5) and (currentlevel.opponenttype<>6) then
        LoadOppSet(currentlevel.opponenttype);
    end;

  end;



end;

procedure JumpSeq(seq: word);
var
curfile: PResFile;
res: PResource;
begin
  curfile := PopCurResFile;
  PopUseResFile(resPrince);
  res := PopGetResource('SEQS', seq);
  PopUseResFile(curfile);
  if res = nil then exit;
  ActiveChar.SeqId := seq;
  ActiveChar.SeqPos := 0;
  if ActiveChar.CharType in [7,8] then
  begin
    if (seq in [130..139]) or (seq = 166) then
    begin
      if ActiveChar.Face = 0 then
      begin
        ActiveChar.Face := -1;
        if ActiveChar.Posn in [150,159] then
          dec(ActiveChar.X, $C);
        RefreshFrames;
        RefreshBlockX;
      end;
    end;

  end;

  
end;

procedure ComputeCharY;
begin
  ActiveChar.Y := ActiveChar.BlockY * 120 + 106;
  if ActiveChar.CharType in [7,8] then
    dec(ActiveChar.Y, $21);
end;

procedure ComputeCharYOnLowered;
var
fore: word;
begin
  if ActiveChar.CharType in [7,8,11] then exit;
  fore := ReadCellOnCharBlock;
  if fore <> CELL_LOWERED then exit;
  if (CharFrame.Flags and $40) = 0 then exit;
  ActiveChar.Y := ActiveChar.BlockY * 120 + 107;
end;

function AddCharX(delta: smallint): smallint;
begin
  if ActiveChar.Face = -1 then
    delta := -delta;
  Result := ActiveChar.X + delta;
end;

function AddFCharX(delta: smallint): smallint;
begin
  if ActiveChar.Face = -1 then
    delta := -delta;
  Result := FCharX + delta;
  FCharX := Result;
end;

procedure AnimChar;
var
gotone: boolean;
seq: pointer;
limit: word;
value: smallint;
v1, v2, v3: smallint;
function GetNextStep(buffer: pointer): smallint;
begin
Result := swap2(pword(integer(buffer) + ActiveChar.SeqPos*2)^);
inc(ActiveChar.SeqPos);
end;
function GetSequence(out limit: word): pointer;
var
curfile: PResFile;
resource: PResource;
begin
curfile := PopCurResFile;
PopUseResFile(resPrince);
resource := PopGetResource('SEQS',ActiveChar.SeqId);
Result := nil;
if (resource <> nil) and (resource^.size > 0) then
begin
  Result := resource^.Data;
  limit := resource^.size;
end;
PopUseResFile(curfile);
end;
begin
gotone := false;
seq := GetSequence(limit);
if seq = nil then exit;

repeat

value := GetNextStep(seq);
case value of
-25: begin ActiveChar.ColorOffset := GetNextStep(seq) end;
-24: begin
  if GetNextStep(seq) <> 0 then
  begin
    value := GetNextStep(seq);
    if (value = $E1) and (currentlevel.leveltype = 6) then
      dec(value, 16);
    //SetPaletteToColorIdx(value);
  end
  else
  begin
    //$242;
  end;
end;
-23: begin end;
-22: begin
v1:= GetNextStep(seq);
v2:= GetNextStep(seq);
v3:= GetNextStep(seq);
if Random(v1) = 0 then
JumpSeq(v2)
else
JumpSeq(v3);

end;
-21: ActiveChar.Status := GetNextStep(seq);
-19: ComputeCharY;
-18: begin end;
-17: begin
  gotone := true;
end;
-16: begin {passe  l'autre niveau} end;
-15: begin GetNextStep(seq); end;
-14: begin GetNextStep(seq); end;
-13: begin end;
-12: begin end;
-11: {SetKidDeathMethod(GetNextStep(seq));} GetNextStep(seq);
-10: GetNextStep(seq);
-9: begin GetNextStep(seq); GetNextStep(seq); end;
-8: begin GetNextStep(seq); GetNextStep(seq); end;
-7: ActiveChar.Action := GetNextStep(seq);
-6: inc(ActiveChar.Y, GetNextStep(seq));
-5: ActiveChar.X := AddCharX(GetNextStep(seq));
-4: inc(ActiveChar.BlockY);
-3: dec(ActiveChar.BlockY);
-2: begin if ActiveChar.CharType = 10 then ActiveChar.X := AddCharX($19); ActiveChar.Face := not ActiveChar.Face; end;
-1: GetNextStep(seq);
else
begin
ActiveChar.Posn := value;
gotone := true;
end;
end;

until (gotone or (ActiveChar.SeqPos >= limit));

end;

procedure SetupKid;
var
kidindex: word;
begin
  if ActiveChar.Posn = 0 then exit;
  RefreshFrames;
  RefreshBlockX;
  SetupChar; //fabrique les F*
  GetCharEdges;
  IndexChar;
  //QuickFloor; //perso partiellement cach.
  ClipChar;
  kidindex := objcount;
  AddCharObj(ActiveChar.CharType);

  if (ActiveChar.Action = 10) or (ActiveChar.Status = 8) then
  begin
    DefineCharPos;
    if ActiveChar.Status = 8 then
      ActiveChar.Status := 0
    else
      ActiveChar.Action := 5;
  end;
  (*
  if currentlevel.LevelType = 5 then
    SetupSplash
  else if currentlevel.leveltype = 1 then
    SetupSand
  else if (currentlevel.levelnumber = 5) and (ActiveChar.Room = 3) and (ActiveChar.Posn = 295) then
    SetupCarpet
  else if (ActiveChar.Posn >= 306) and (ActiveChar.Posn <= 318) then
    SetupFlame
  else if CharAFrame.AFrmType = 5 then
  begin
    SetupFireball;
    objlist[kidindex].Attached := objcount - 1;
  end;
  *)

  if (ActiveChar.CharType = 1) and (currentlevel.LevelType = 6) then
    SetupShadowFlame;

  if (CharAFrame.AFrmType = 1) and (ActiveChar.Status = 5) then
  begin
    SetupSword(3);
    objlist[kidindex].Attached := objcount - 1;
  end;

  if (CharAFrame.AFrmType = 3) then
  begin
    SetupFlask;
    objlist[kidindex].Attached := objcount - 1;
  end;

end;

procedure Opponent1;
var
oppindex: word;
ctr:integer;
begin
for ctr := 0 to currentlevel.RoomGuards[currentroom-1].count - 1 do
begin
  LoadShad(ctr);
  SetupOpponent;
  SaveShad(ctr);
  if ActiveChar.Action <> 9 then
  begin
    oppindex := objcount - 1;
  end
  else
  begin
    oppindex := objcount -1;
    objlist[oppindex].Attached := 100;

  end;

  if ((ActiveChar.Action = 10) or (ActiveChar.Status = 8) or ((ActiveChar.Action = 9) and (ActiveChar.Posn = $D5))) and
  not (ActiveChar.CharType in [7,8]) then
  begin
    if (ActiveCHar.Action = 10) then
      ActiveChar.ACtion := 5;
    DefineCharPos;
  end;
  if (ActiveCHar.CharType <> 10) and (ActiveCHar.CharType <> 1) and (ActiveChar.Status<>5) and (CharAFrame.AFrmType = 1) then
  begin
    SetupSword(9);
    if ActiveChar.Action <> 9 then
      objlist[oppindex].Attached := objcount - 1
    else
    begin
      objlist[objcount - 1].Attached := 100;
    end;
  end;
  SaveShad(ctr);
  
end;


end;

procedure SetupChar;
begin
  if ActiveChar.Posn = 0 then exit;
  if (CharFrame.Imgid = -1) and (CharAFrame.imgid = -1) then exit;
  FCharFace := ActiveChar.Face;
  FColorOffset := ActiveChar.ColorOffset;
  if ActiveCHar.CharType in [0,1,6] then
  begin
    FCharSet := 2;
    FCharImg := CharFrame.ImgId;
  end
  else
  begin
    FCharSet := 3;
    if ActiveChar.CharType = 10 then
      FCharImg := CharAFrame.ImgId
    else
      FCharImg := CharFrame.ImgId;
  end;
  if not (ActiveChar.CharType in [7,8]) or (ActiveChar.Status <> 1) then
  begin
    FCharY := ActiveChar.Y + CharFrame.DeltaY;
    FCharX := AddCharX(CharFrame.DeltaX) - $CF;
    if ActiveChar.chartype = 10 then
    begin
      //truc
    end
    else if ActiveChar.CharType = 4 then
    begin
      if ActiveChar.Posn in [$CE..$D1] then
      begin
        FCharSet := 4;
        inc(FCharImg, $6D);
      end;
    end;
  end
  else
  begin
    //AlignHeadOnKidNeck;
  end;
end;

procedure GetCharEdges;
var
imgsize: TMacPoint;
adelta: smallint;
rect: TMacRect;
begin
  ActiveChar.Rect.TOp := 0;
  ActiveChar.Rect.Left := 0;
  ActiveChar.Rect.Bottom := 0;
  ActiveChar.Rect.Right := 0;
  if FCharImg = -1 then exit;
  if FCharSet = 4 then
  begin
    if not GetBGSetImgSize(FCharImg, imgsize) then exit;
  end
  else
  begin
    if not PrinceGetnShapeItemSize(shapesets[FCharSet], FCharImg+1, imgsize) then exit;
  end;
  tempwidth := imgsize.x + 1;
  tempheight := imgsize.y;
  adelta := GetAFrameDelta;
  templeft1 := FCharX + $CF;
  if ActiveChar.Face = 0 then
    dec(templeft1, tempwidth)
  else
    dec(templeft1, adelta);
  inc(tempwidth, adelta);
  templeft2 := templeft1;
  tempright1 := templeft1 + tempwidth;
  tempright2 := tempright1;
  temptop := FCharY - tempheight + 1;
  if temptop > 365 then
    temptop := 365;
  rect.top := temptop;
  rect.bottom := FCharY + 1;
  if FCharFace = -1 then
  begin
    rect.left := FCharX;
    rect.right := FCharX + imgsize.x;
  end
  else
  begin
    rect.right := FCharX;
    rect.left := FCharX - imgsize.x;
  end;
  if SectRect(BackBuffer.Rect, rect, rect) then
    ActiveChar.Rect := rect;
  FCharBlockTop := GetRow(temptop);
  FCharBlockBottom := GetRow(tempbottom);
  if FCharBlockBottom = -1 then
    FCharBlockBottom := 3;
  FCharBlockLeft := GetCol(templeft1);
  FCharBlockRight := GetCol(tempright1);
  if FCharBlockLeft < 0 then
    FCharBlockLeft := 0;
  if FCharBlockRight > 9 then
    FCharBlockRight := 9;
end;

procedure IndexChar;
var
myleft, mybottom: smallint;
begin
  if ActiveChar.Action = 1 then
  begin
    myleft := FCharBlockLeft;
    mybottom := FCharBlockBottom;
  end
  else
  begin
    myleft := ActiveChar.BlockX;
    mybottom := ActiveChar.BlockY;
  end;
  if (ActiveChar.Posn in [135..149]) or (ActiveChar.Action in [2,3,4,6])  then
  begin
    if ActiveChar.Face = 0 then
      dec(myleft)
    else
      inc(myleft);
    FCharIdx := IndexCell1(myleft, mybottom);

  end;

end;

procedure ClipChar;
begin
  MakeFCharClipRect;
  //ca va suffire pour l'instant.
end;


procedure AddCharObj(chartype: word);
begin
  if ObjCount >= 30 then exit;
  with ObjList[ObjCount] do
  begin
    ConvertX(FCharX, X);
    ObjType := CharType;
    Y := FCharY;
    ImgSet := FCharSet;
    ImgID := FCharImg;
    Face := FCharFace;
    Rect := FCharClipRect;
    ColorOffset := FColorOffset;
    if chartype in [3,9] then
      Attached := -1
    else
      Attached := 0;
    Posn := ActiveChar.Posn;
    Idx := ActiveChar.Index;
  end;
  inc(ObjCount);
end;

procedure MakeFCharClipRect;
var
imgsize: TMacPoint;
hassize: boolean;
begin
  if FCharImg <> -1 then
  begin
    if FCharSet = 4 then
      hassize := GetBGSetImgSize(FCharImg, imgsize)
    else
      hassize := PrinceGetnShapeItemSize(shapesets[FCharSet], FCharImg+1, imgsize);
    if hassize then
    begin
      FCharClipRect.top := FCharY - imgsize.y;
      FCharClipRect.bottom := FCharY + 1;
      if FCharFace = 0 then
      begin
        FCharClipRect.Right := FCharX;
        FCharClipRect.Left := FCharX - imgsize.x;
      end
      else
      begin
        FCharClipRect.Left := FCharX;
        FCharClipRect.Right := FCharX + imgsize.x;
      end;
      SectRect(backbuffer.Rect, FCharClipRect, FCharClipRect);
    end
    else
    begin
      FillChar(FCharClipRect.top, sizeof(TMacRect), 0);
    end;
  end
  else
  begin
    FillChar(FCharClipRect.top, sizeof(TMacRect), 0);
  end;
end;

procedure DefineCharPos;
begin
  SaveFChar;
  FCharIdx := -1;
  FCharSet := 2;
  FCharImg := 218;
  FColorOffset := 16;
  if (ActiveChar.Posn = 185) or (ActiveChar.Posn in [106..111]) then
  begin
    inc(FCharY, 8);
    AddFCharX(19);
  end
  else if ActiveChar.CharType = $B then
  begin
    inc(FCharY, 7);
    AddFCharX(-12);
    FCharSet := 3;
    FCharImg := $7F;
  end
  else if ActiveChar.CharType = $C then
  begin
    dec(FCharY, 21);
    AddFCharX(-12);
  end
  else if ActiveChar.CharType = 0 then
  begin
    if (ActiveOpp.CharType = 11) or(ActiveChar.Posn = 265) then
      AddFCharX(14)
    else if (ActiveChar.Posn in [138..140]) then
    begin
      dec(FCharY, 15);
      AddFCharX(-7)
    end
    else if ActiveChar.Posn = 338 then
    begin
      dec(FCharY, 90);
      AddFCharX(30);
    end
    else if ActiveChar.Posn = 340 then
      dec(FCharY, 80)
    else
    begin
      dec(FCharY, 30);
      AddFCharX(14);
    end;
  end
  else
  begin
    dec(FCharY, 21);
    AddFCharX(11);

  end;
  MakeFCharClipRect;
  AddCharObj(5);
  if ActiveChar.Action = 9 then
    objlist[objcount - 1].Attached := 100;

  LoadFChar;

  
end;

procedure SetupSword(swordtype: word);
begin
  if (CharAFrame.AFrmType <> 1) or (ActiveChar.Status = 5) then exit;
  FCharImg := CharAFrame.ImgID;
  AddFCharX(CharAFrame.DeltaX);
  inc(FCharY, CharAFrame.DeltaY);
  FCharSet := 0;
  FColorOffset := 0;
  MakeFCharClipRect;
  if currentlevel.LevelType = 5 then
  begin

  end;
  AddCharObj(swordtype);
  
  
end;

procedure SetupFlask;
begin
  if CharAFrame.AFrmType <> 3 then exit;
  FColorOffset := 0;
  FCharImg := CharAFrame.ImgID;
  AddFCharX(CharAFrame.DeltaX);
  inc(FCharY, CharAFrame.DeltaY);
  FCharSet := 1;
  MakeFCharClipRect;
  AddCharObj(3);
end;

procedure SetupOpponent;
begin
  RefreshFrames;
  RefreshBlockX;
  SetupChar;
  ComputeCharYOnLowered;
  GetCharEdges;
  IndexChar;
  //QuickFloor;
  ClipChar;
  if ActiveCHar.CharType in [1,6,7,8,10] then
    AddCharObj(ActiveChar.CharType)
  else
    AddCharObj(2);
  
end;

function GetBaseX: smallint;
begin
  AddCHarX(CharFrame.DeltaX - (CharFrame.Flags and $3F))
end;

function GetDist:smallint;
begin
Result := GetDist1(GetBaseX);
end;

function GetDist1(x: smallint): smallint;
begin
  GetCharCol(x);
  if ActiveChar.Face = 0 then
    Result := 50 - ColOffset
  else
    Result := ColOffset;
end;

function GetCharCol(x: smallint): smallint;
begin
  Result := GetCol(x-22);
end;

end.
