unit uDraw;

interface

uses uRect, uPop2Types, uMacTypes;

procedure PaintCopy(src: pbyte; dest: pbyte; srcpitch: word; destpitch: word; paintwidth: word; paintheight: word);
procedure PaintTrans(src: pbyte; dest: pbyte; srcpitch: word; destpitch: word; paintwidth: word; paintheight: word);
procedure DrawIt(shapedata: pointer; stuff: pointer; left: smallint; top: smallint; transparent: word; coloroffset: smallint; var returnedsize: TMacRect);
procedure PaintRLE(src: pbyte; dest: pbyte; transparent: word; width: word; height: word; srcx: smallint; srcy: smallint; destx: smallint; desty: smallint);
procedure PaintRLELR(src: pbyte; dest: pbyte; transparent: word; width: word; height: word; srcx: smallint; srcy: smallint; destx: smallint; desty: smallint);
procedure PaintRLETB(src: pbyte; dest: pbyte; transparent: word; width: word; height: word; srcx: smallint; srcy: smallint; destx: smallint; desty: smallint);
procedure BankRLE(src: pbyte; dest: pbyte; width: word; height: word; srcx: smallint; srcy: smallint; destx: smallint; desty: smallint; coloroffset: smallint);
procedure BankRLELR(src: pbyte; dest: pbyte; width: word; height: word; srcx: smallint; srcy: smallint; destx: smallint; desty: smallint; coloroffset: smallint);
procedure PrincePaintShapeIdx(shapeset: PShapeList; item: integer; left: smallint; top: smallint; coloroffset: smallint);

implementation

uses Math, uSwapper, uGlobals, uShapeList;

procedure PaintCopy(src: pbyte; dest: pbyte; srcpitch: word; destpitch: word; paintwidth: word; paintheight: word);
var
srcrow: pbyte;
destrow: pbyte;
seconddestrow: pbyte;
srcpix: pbyte;
destpix: pbyte;
  ctr: Integer;
  ctr2: Integer;
begin
//Copie  peu prs directe.
srcrow := src;
destrow := dest;
seconddestrow := backbuffer.secondoffset;
//inc(destrow); //On avance d'un byte pour s'aligner.

for ctr := 0 to paintheight - 1 do
begin
  destpix := destrow;
  srcpix := srcrow;

  Move(srcpix^, destpix^, paintwidth);
  fillchar(backbuffer.secondoffset^,paintwidth, backbuffer.SecondValue);

  inc(destrow, destpitch);
  inc(seconddestrow, destpitch);
  inc(srcrow, srcpitch);
end;

end;

procedure PaintTrans(src: pbyte; dest: pbyte; srcpitch: word; destpitch: word; paintwidth: word; paintheight: word);
var
srcrow: pbyte;
destrow: pbyte;
destrow2: pbyte;
srcpix: pbyte;
destpix: pbyte;
destpix2: pbyte;
  ctr: Integer;
  ctr2: Integer;
begin
//Comme au dessus mais dessine pas si pixel vide (valeur 0)
srcrow := src;
destrow := dest;
destrow2 := backbuffer.secondoffset;
//inc(destrow); //On avance d'un byte pour s'aligner.

for ctr := 0 to paintheight - 1 do
begin
  destpix := destrow;
  destpix2 := destrow2;
  srcpix := srcrow;
  for ctr2 := 0 to paintwidth - 1 do
  begin
    if srcpix^ <> 0 then
    begin
      destpix^ := srcpix^; //ca pte le range mais c'est pas grave.
      destpix2^ := backbuffer.secondvalue; //ca pte le range mais c'est pas grave.
    end;
    inc(destpix);
    inc(destpix2);
    inc(srcpix);
  end;
  inc(destrow, destpitch);
  inc(destrow2, destpitch);
  inc(srcrow, srcpitch);
end;

end;

procedure DrawIt(shapedata: pointer; stuff: pointer; left: smallint; top: smallint; transparent: word; coloroffset: smallint; var returnedsize: TMacRect);
var
shaperect: TMacRect;
ResultRect: TMacRect;
firstcol: smallint;
firstrow: smallint;
destheight: smallint;
destwidth: smallint;
code: word;
srcpitch: word;
dest: pbyte;
src: pbyte;
fullcoloroffset: cardinal;
first: byte;
bigstuff: pointer;
  ctr: Integer;
pitch: word;
prevvalue: byte;
begin
inc(backbuffer.SecondValue);
backbuffer.SecondOffset := backbuffer.SecondBuffer;
if shapedata <> nil then
begin
shaperect.left := left;
shaperect.Top := top;
shaperect.Right := left + swap2(pword(integer(shapedata) + 4)^);
shaperect.Bottom := top + swap2(pword(integer(shapedata) + 6)^);
if SectRect(shaperect, backbuffer.ClipRect, ResultRect) then
begin
  //On peut encore dessiner.
  first := swap2(psmallint(shapedata)^);
  firstcol := ResultRect.Left - shaperect.left + (first and $F);
  firstrow := ResultRect.Top - shaperect.Top;
  destheight := ResultRect.Bottom - ResultRect.Top;
  destwidth := ResultRect.Right - ResultRect.Left;
  code := swap2(pword(shapedata)^);
  code := code and $FF80;
  if code = $B000 then
  begin
    srcpitch := swap2(pword(integer(shapedata) + 2)^);
    src := shapedata;
    inc(src, $C);
    dest := backbuffer.Buffer;
    backbuffer.secondoffset := backbuffer.SecondBuffer;
    inc(src, firstrow*srcpitch + firstcol);
    inc(dest, ResultRect.Top * backbuffer.Pitch + ResultRect.Left);
    inc(backbuffer.secondoffset, ResultRect.Top * backbuffer.Pitch + ResultRect.Left);
    if transparent = $10 then
      PaintTrans(src, dest, srcpitch, backbuffer.Pitch, destwidth, destheight)
    else
      PaintCopy(src, dest, srcpitch, backbuffer.Pitch, destwidth, destheight);
  end
  else if code = $B100 then
  begin
   if coloroffset > 1 then
   begin
     dec(coloroffset);
     fullcoloroffset := coloroffset shl 8;
     fullcoloroffset := fullcoloroffset or coloroffset;
     fullcoloroffset := fullcoloroffset or (fullcoloroffset shl 16);
     code := first and $30;
     if code = $10 then
     begin
        BankRLELR(shapedata, BackBuffer.Buffer, destwidth, destheight, swap2(pword(integer(shapedata) + 4)^) - (destwidth + firstcol), firstrow, ResultRect.Left, ResultRect.top, fullcoloroffset);
     end
     else
     begin
       BankRLE(shapedata, BackBuffer.Buffer, destwidth, destheight, firstcol, firstrow, ResultRect.Left, ResultRect.top, fullcoloroffset);
     end;
   end
   else
   begin
     code := first and $30;
     if code = $20 then
     begin
       PaintRLETB(shapedata, backbuffer.Buffer, transparent, destwidth, destheight, firstcol, firstrow, resultrect.left, resultrect.top);
     end
     else if code = $10 then
     begin
       PaintRLELR(shapedata, backbuffer.Buffer, transparent, destwidth, destheight, firstcol, firstrow, resultrect.left, resultrect.top);
     end
     else
      PaintRLE(shapedata, backbuffer.Buffer, transparent, destwidth, destheight, firstcol, firstrow, resultrect.left, resultrect.top);
   end;
  end
  else if (code = $9000) or (code = $9100) then
  begin

  end;
end;
end
else if stuff <> nil then
begin
  code := swap2(pword(stuff)^);
  if (code and $3000) = $1000 then
  begin
    pitch := swap2(pword(integer(stuff)+2)^);
    bigstuff := AllocMem((pitch shl 3)*swap2(pword(integer(stuff)+6)^)+12);
    dest := bigstuff;
    src := stuff;
    move(src^, dest^, 12);
    inc(src, 12);
    inc(dest, 2);
    srcpitch := swap2(pword(dest)^) shl 3;
    pword(dest)^ := swap2(srcpitch);
    inc(dest, 10);
    for ctr := 0 to pitch*swap2(pword(integer(stuff)+6)^) - 1 do
    begin
      if (src^ and $80) <> 0 then dest^ := coloroffset else dest^ := 0; inc(dest);
      if (src^ and $40) <> 0 then dest^ := coloroffset else dest^ := 0; inc(dest);
      if (src^ and $20) <> 0 then dest^ := coloroffset else dest^ := 0; inc(dest);
      if (src^ and $10) <> 0 then dest^ := coloroffset else dest^ := 0; inc(dest);
      if (src^ and $08) <> 0 then dest^ := coloroffset else dest^ := 0; inc(dest);
      if (src^ and $04) <> 0 then dest^ := coloroffset else dest^ := 0; inc(dest);
      if (src^ and $02) <> 0 then dest^ := coloroffset else dest^ := 0; inc(dest);
      if (src^ and $01) <> 0 then dest^ := coloroffset else dest^ := 0; inc(dest);
      inc(src);
    end;

    shaperect.left := left;
    shaperect.Top := top;
    shaperect.Right := left + swap2(pword(integer(bigstuff) + 4)^);
    shaperect.Bottom := top + swap2(pword(integer(bigstuff) + 6)^);
    if SectRect(shaperect, backbuffer.ClipRect, ResultRect) then
    begin
      //On peut encore dessiner.
      first := swap2(psmallint(bigstuff)^);
      firstcol := ResultRect.Left - shaperect.left + (first and $F);
      firstrow := ResultRect.Top - shaperect.Top;
      destheight := ResultRect.Bottom - ResultRect.Top;
      destwidth := ResultRect.Right - ResultRect.Left;

    src := bigstuff;
    inc(src, 12);
    dest := backbuffer.Buffer;
    inc(src, firstrow*srcpitch + firstcol);
    inc(dest, ResultRect.Top * backbuffer.Pitch + ResultRect.Left);
    inc(backbuffer.secondoffset, ResultRect.Top * backbuffer.Pitch + ResultRect.Left);


      PaintTrans(src, dest, srcpitch, backbuffer.Pitch, destwidth, destheight);


    end;
    freemem(bigstuff);

  end;
end;
returnedsize := ResultRect;
end;

procedure PaintRLE(src: pbyte; dest: pbyte; transparent: word; width: word; height: word; srcx: smallint; srcy: smallint; destx: smallint; desty: smallint);
var
destpitch: cardinal;
  ctr: Integer;
linestart: pbyte;
xpos: smallint;
b1: byte;
skip: byte;
val: byte;
destrow: pbyte;
destrow2: pbyte;
begin
  destpitch := backbuffer.Pitch;
  inc(dest, destpitch * desty + destx);
  inc(backbuffer.SecondOffset, destpitch * desty + destx);
  inc(src, $C); //saute par dessus l'en-tte.
  for ctr := 0 to srcy - 1 do
    inc(src, swap2(pword(src)^) + 2);
  linestart := src;
  destrow := dest;
  destrow2 := backbuffer.SecondOffset;
  for ctr := 0 to height - 1 do
  begin
    dest := destrow;
    backbuffer.secondoffset := destrow2;
    inc(src, 2);
    //xpos := width - srcx;
    xpos := 0;
    while xpos < (width + srcx) do
    begin
      b1 := src^;
      inc(src);
      if (b1 and $80) <> 0 then //fill
      begin
        b1 := b1 and $7F;
        inc(b1); //ca devient le nbr de bytes concerns.
        if xpos < srcx then
        begin
          skip := min(srcx-xpos, b1);
          dec(b1, skip);
          inc(xpos, skip);
        end;
        if b1 > $80 then
          dec(b1);
        if b1 > 0 then
        begin
          //Il reste de quoi  copier.
          b1 := min(width + srcx - xpos, b1);
          val := src^;
          if (transparent = 0) or (val <> 0) then
          begin
            fillchar(dest^, b1, val);
            fillchar(backbuffer.Secondoffset^, b1, backbuffer.SecondValue);
          end;
          inc(dest, b1);
          inc(backbuffer.secondoffset, b1);
          inc(xpos, b1);
        end;
        inc(src); //saute par dessus le byte de remplissage.
      end
      else
      begin
        inc(b1);
        if xpos < srcx then
        begin
          skip := min(srcx-xpos, b1);
          dec(b1, skip);
          inc(src, skip);
          inc(xpos, skip);
        end;
        if b1 > $80 then
          dec(b1);
        if b1 > 0 then
        begin
          b1 := min(width + srcx - xpos, b1);
          while b1 > 0 do
          begin
          if (src^ <> 0) or (transparent = 0) then
          begin
            move(src^, dest^, 1);
            backbuffer.SecondOffset^ := backbuffer.SecondValue;
          end;
          inc(src);
          inc(dest);
          inc(backbuffer.SecondOffset);
          inc(xpos);
          dec(b1);
          end;
        end;


      end;

    end;

    inc(linestart, 2+swap2(pword(linestart)^));
    src := linestart;
    inc(destrow, destpitch);
    inc(destrow2, destpitch);
  end;

end;


procedure PaintRLELR(src: pbyte; dest: pbyte; transparent: word; width: word; height: word; srcx: smallint; srcy: smallint; destx: smallint; desty: smallint);
var
  destpitch: cardinal;
  ctr: Integer;
  linestart: pbyte;
  xpos: smallint;
  b1: byte;
  skip: byte;
  val: byte;
  destrow: pbyte;
  destrow2: pbyte;
  ctr2: Integer;
begin
  destpitch := backbuffer.Pitch;
  inc(dest, destpitch * desty + destx);
  inc(backbuffer.secondoffset, destpitch * desty + destx);
  inc(src, $C); //saute par dessus l'en-tte.
  for ctr := 0 to srcy - 1 do
    inc(src, swap2(pword(src)^) + 2);
  linestart := src;
  destrow := dest;
  destrow2 := backbuffer.secondoffset;
  for ctr := 0 to height - 1 do
  begin
    dest := destrow;
    backbuffer.secondoffset := destrow2;
    inc(dest, width);
    inc(backbuffer.secondoffset, width);
    inc(src, 2);
    //xpos := width - srcx;
    xpos := 0;
    while xpos < (width + srcx) do
    begin
      b1 := src^;
      inc(src);
      if (b1 and $80) <> 0 then //fill
      begin
        b1 := b1 and $7F;
        inc(b1); //ca devient le nbr de bytes concerns.
        if xpos < srcx then
        begin
          skip := min(srcx-xpos, b1);
          dec(b1, skip);
          inc(xpos, skip);
        end;
        if b1 > 0 then
        begin
          //Il reste de quoi  copier.
          b1 := min(width + srcx - xpos, b1);
          val := src^;
          //recule AVANT de faire le fill.
          dec(dest, b1);
          dec(backbuffer.secondoffset, b1);
          if (transparent = 0) or (val <> 0) then
          begin
            fillchar(dest^, b1, val);
            fillchar(backbuffer.secondoffset^, b1, backbuffer.SecondValue);
          end;
          inc(xpos, b1);
        end;
        inc(src); //saute par dessus le byte de remplissage.
      end
      else
      begin
        inc(b1);
        if xpos < srcx then
        begin
          skip := min(srcx-xpos, b1);
          dec(b1, skip);
          inc(src, skip);
          inc(xpos, skip);
        end;
        if b1 > 0 then
        begin
          b1 := min(width + srcx - xpos, b1);
          //copie  l'envers
          while b1 > 0 do
          begin
          dec(dest);
          dec(backbuffer.secondoffset);
          if (src^ <> 0) or (transparent = 0) then
          begin
            dest^ := src^;
            backbuffer.secondoffset^ := backbuffer.SecondValue;
          end;
          inc(src);
          inc(xpos);
          dec(b1);
          end;
        end;


      end;

    end;

    inc(linestart, 2+swap2(pword(linestart)^));
    src := linestart;
    inc(destrow, destpitch);
    inc(destrow2, destpitch);
  end;

end;


procedure PaintRLETB(src: pbyte; dest: pbyte; transparent: word; width: word; height: word; srcx: smallint; srcy: smallint; destx: smallint; desty: smallint);
var
destpitch: cardinal;
  ctr: Integer;
linestart: pbyte;
xpos: smallint;
b1: byte;
skip: byte;
val: byte;
destrow: pbyte;
begin
  destpitch := backbuffer.Pitch;
  inc(dest, destpitch * (desty + height) + destx);
  for ctr := 0 to srcy - 1 do
    inc(src, swap2(pword(src)^) + 2);
  linestart := src;
  destrow := dest;
  for ctr := 0 to height - 1 do
  begin
    dec(destrow, destpitch);
    dest := destrow;
    inc(src, 2);
    xpos := width - srcx;

    while xpos < width do
    begin
      b1 := src^;
      inc(src);
      if (b1 and $80) <> 0 then //fill
      begin
        b1 := b1 and $7F;
        inc(b1); //ca devient le nbr de bytes concerns.
        if xpos < 0 then
        begin
          skip := min(-xpos, b1);
          dec(b1, skip);
          inc(xpos, skip);
        end;
        if b1 > 0 then
        begin
          //Il reste de quoi  copier.
          b1 := min(width - xpos, b1);
          val := src^;
          if (transparent <> 0) or (val <> 0) then
            fillchar(dest^, b1, val);
          inc(dest, b1);
          inc(xpos, b1);
        end;
        inc(src^); //saute par dessus le byte de remplissage.
      end
      else
      begin
        inc(b1);
        if xpos < 0 then
        begin
          skip := min(-xpos, b1);
          dec(b1, skip);
          inc(src, skip);
          inc(xpos, skip);
        end;
        if b1 > 0 then
        begin
          b1 := min(width - xpos, b1);
          move(src^, dest^, b1);
          inc(src, b1);
          inc(dest, b1);
          inc(xpos, b1);
        end;
      end;

    end;

    inc(linestart, 2+swap2(pword(linestart)^));
    src := linestart;
  end;

end;




procedure BankRLE(src: pbyte; dest: pbyte; width: word; height: word; srcx: smallint; srcy: smallint; destx: smallint; desty: smallint; coloroffset: smallint);
var
destpitch: cardinal;
  ctr: Integer;
linestart: pbyte;
xpos: smallint;
b1: byte;
skip: byte;
val: byte;
destrow: pbyte;
destrow2: pbyte;
begin
  destpitch := backbuffer.Pitch;
  inc(dest, destpitch * desty + destx);
  inc(backbuffer.SecondOffset, destpitch * desty + destx);
  inc(src, $C); //saute par dessus l'en-tte.
  for ctr := 0 to srcy - 1 do
    inc(src, swap2(pword(src)^) + 2);
  linestart := src;
  destrow := dest;
  destrow2 := backbuffer.SecondOffset;
  for ctr := 0 to height - 1 do
  begin
    dest := destrow;
    backbuffer.SecondOffset := destrow2;
    inc(src, 2);
    //xpos := width - srcx;
    xpos := 0;
    while xpos < (width + srcx) do
    begin
      b1 := src^;
      inc(src);
      if (b1 and $80) <> 0 then //fill
      begin
        b1 := b1 and $7F;
        inc(b1); //ca devient le nbr de bytes concerns.
        if xpos < srcx then
        begin
          skip := min(srcx-xpos, b1);
          dec(b1, skip);
          inc(xpos, skip);
        end;
        if b1 > 0 then
        begin
          //Il reste de quoi  copier.
          b1 := min(width + srcx - xpos, b1);
          val := src^;
          if (val <> 0) then
          begin
            fillchar(dest^, b1, val + (coloroffset and $FF));
            fillchar(backbuffer.SecondOffset^, b1, backbuffer.secondvalue);
          end;
          inc(dest, b1);
          inc(backbuffer.SecondOffset, b1);
          inc(xpos, b1);
        end;
        inc(src); //saute par dessus le byte de remplissage.
      end
      else
      begin
        inc(b1);
        if xpos < srcx then
        begin
          skip := min(srcx-xpos, b1);
          dec(b1, skip);
          inc(src, skip);
          inc(xpos, skip);
        end;
        if b1 > 0 then
        begin
          b1 := min(width - xpos, b1);
          while b1 > 0 do
          begin
          if (src^ <> 0) then
          begin
            move(src^, dest^, 1);
            backbuffer.SecondOffset^ := backbuffer.SecondValue;
            dest^ := dest^ + (coloroffset and $FF)
          end;
          inc(src);
          inc(dest);
          inc(backbuffer.SecondOffset);
          inc(xpos);
          dec(b1);
          end;
        end;


      end;

    end;

    inc(linestart, 2+swap2(pword(linestart)^));
    src := linestart;
    inc(destrow, destpitch);
    inc(destrow2, destpitch);
  end;

end;

procedure BankRLELR(src: pbyte; dest: pbyte; width: word; height: word; srcx: smallint; srcy: smallint; destx: smallint; desty: smallint; coloroffset: smallint);
var
  destpitch: cardinal;
  ctr: Integer;
  linestart: pbyte;
  xpos: smallint;
  b1: byte;
  skip: byte;
  val: byte;
  destrow: pbyte;
  destrow2: pbyte;
begin
  destpitch := backbuffer.Pitch;
  inc(dest, destpitch * desty + destx);
  inc(backbuffer.SecondOffset, destpitch * desty + destx);
  inc(src, $C); //saute par dessus l'en-tte.
  for ctr := 0 to srcy - 1 do
    inc(src, swap2(pword(src)^) + 2);
  linestart := src;
  destrow := dest;
  destrow2 := backbuffer.SecondOffset;
  for ctr := 0 to height - 1 do
  begin
    dest := destrow;
    backbuffer.SecondOffset := destrow2;
    inc(dest, width);
    inc(backbuffer.SecondOffset, width);
    inc(src, 2);
    //xpos := width - srcx;
    xpos := 0;
    while xpos < (width + srcx) do
    begin
      b1 := src^;
      inc(src);
      if (b1 and $80) <> 0 then //fill
      begin
        b1 := b1 and $7F;
        inc(b1); //ca devient le nbr de bytes concerns.
        if xpos < srcx then
        begin
          skip := min(srcx-xpos, b1);
          dec(b1, skip);
          inc(xpos, skip);
        end;
        if b1 > 0 then
        begin
          //Il reste de quoi  copier.
          b1 := min(width + srcx - xpos, b1);
          val := src^;
          //recule AVANT de faire le fill.
          dec(dest, b1);
          dec(backbuffer.SecondOffset, b1);
          if (val <> 0) then
          begin
            fillchar(dest^, b1, val + (coloroffset and $FF));
            fillchar(backbuffer.SecondOffset^, b1, backbuffer.secondvalue);
          end;

          inc(xpos, b1);
        end;
        inc(src); //saute par dessus le byte de remplissage.
      end
      else
      begin
        inc(b1);
        if xpos < srcx then
        begin
          skip := min(srcx-xpos, b1);
          dec(b1, skip);
          inc(src, skip);
          inc(xpos, skip);
        end;
        if b1 > 0 then
        begin
          b1 := min(width - xpos, b1);
          while b1 > 0 do
          begin
          dec(dest);
          dec(backbuffer.SecondOffset);
          if (src^ <> 0) then
          begin
            move(src^, dest^, 1);
            dest^ := dest^ + (coloroffset and $FF);
            backbuffer.SecondOffset^ := backbuffer.SecondValue;
          end;
          inc(src);
          inc(xpos);
          dec(b1);
          end;
        end;
      end;

    end;

    inc(linestart, 2+swap2(pword(linestart)^));
    src := linestart;
    inc(destrow, destpitch);
    inc(destrow2, destpitch);
  end;

end;

procedure PrincePaintShapeIdx(shapeset: PShapeList; item: integer; left: smallint; top: smallint; coloroffset: smallint);
var
shape: pointer;
printsize: TMacRect;
begin
shape := PrinceGetnShapeItem(shapeset, item);
DrawIt(shape, nil, left, top, $10, coloroffset, printsize);
end;




end.
