unit uDrawBF;

interface

uses uImgTables;

procedure DrawBFItem(item: PBFImgEntry);
procedure DrawMidItem(item: PMidImgEntry);
procedure DumpBackTable;
procedure FinalDrawForeTable;
procedure DumpForeTable;
procedure DumpTable(table: word);
procedure DumpTables;
procedure DumpMidTable1;
procedure DumpMidTable2;

implementation

uses uGlobals, uShapesets, uShapeList, uMacTypes, uRect,
uSwapper, uPop2Types, uShapes, uDraw, uColorTables, uChars, uFrames;

procedure DrawBFItem(item: PBFImgEntry);
var
shape: pointer;
rect:TMacRect;
piece: PCustomPiece;
transparent: word;
coloroffset: smallint;
altshape: pointer;
oldclip: TMacRect;
begin
coloroffset := 0;
if shapesets[item^.ImgSet].NbItems >= item^.ItemID then
begin
  if (item^.ImgSet = 4) and (currentlevel.LevelType = 5) and drawingfull and (item^.ItemId=122) then
  begin
    if item^.ImgSet = 4 then
      shape := GetBGSetShapeItem(item^.ItemID)
    else
      shape := PrinceGetnShapeItem(shapesets[item^.ImgSet], item^.ItemId);

    rect.top := item^.Top;
    rect.left := item^.Left;
    rect.right := rect.left + swap2(pword(integer(shape) + 4)^);
    rect.bottom := rect.top + swap2(pword(integer(shape) + 6)^);
    //AddPeel(rect, item^.ItemId + 200);
  end;

  if item^.ImgSet = 4 then
    shape := GetBGSetShapeItem(item^.ItemID)
  else
    shape := PrinceGetnShapeItem(shapesets[item^.ImgSet], item^.ItemId);
  if shape = nil then exit;
end
else
begin
  if (custompieces = nil) and (item^.ItemID <> 25360) then exit;

  if item^.ItemID = 25360 then
    shape := GetHorseShape
  else if (item^.ItemID >= 25302) and (item^.ItemID <= 25319) then
  begin
    //SaveUnderCarpet;
    shape := GetCarpetShape(item^.ItemID - 25302);
    item^.Flip := 0;
  end
  else
  begin
    if custompieces = nil then exit;

    if (length(flameshapes) > 0) and (item^.itemid >= 4077) and (item^.itemid <= 4122) then
      coloroffset := $E0;
    

    piece := @custompieces^.content[item^.itemid - custompieces^.firstid];
    if piece^.var_1A = 1 then
    begin
      //AddCustomPiecePeel(piece, item^.ClippedRect);
    end;
    shape := piece^.shape;
    item^.Flip := 0;
  end;
end;
if shape = nil then
shape := nil;
if item^.Flip = 0 then
  FlipSHAP(shape, 0)
else
  FlipSHAP(shape, 1);

if (swap2(pword(shape)^) and $FF80) = $9000 then
begin
coloroffset := item^.transparent;
altshape := shape;
shape := nil;
end
else
begin
altshape := nil;
end;

oldclip := BackBuffer.Cliprect;
BackBuffer.ClipRect := Item^.ClippedRect;

//if item^.iscustom then
//backbuffer.secondvalue := $50
//else
//backbuffer.secondvalue := item^.partfore;

DrawIt(shape, altshape, item^.left, item^.Top, item^.Transparent, coloroffset, rect);

BackBuffer.ClipRect := oldclip;

//CheckAddDRect(rect);


end;

procedure DrawMidItem(item: PMidImgEntry);
var
shape: pointer;
color: word;
rect: TMacRect;
left: smallint;
begin
  if (item^.ImgID >= 25302) and (item^.ImgID <= 25319) then
    shape := GetCarpetShape(item^.ImgID - 25304)
  else if (currentlevel.LevelNumber = 5) and (currentroom = 10) and (item^.ImgSet = 4) and (item^.ImgID < custompieces^.NBItems) then
    shape := custompieces.Content[item^.ImgID].shape //GetCustomPieceShape(item^.ImgID)
  else if (length(flameshapes) > 0) and (item^.ImgID >= 4077) and (item^.ImgID <= 4122) then
    shape := flameshapes[item^.ImgID - 4077]// GetFlameImgHnd(item^.ImgID)
  else
  begin
    if item^.ImgSet = 4 then
      shape := GetBGSetShapeItem(item^.ImgID+1)
    else
      shape := PrinceGetnShapeItem(shapesets[item^.ImgSet], item^.ImgID+1);

  end;
  if (item^.ImgSet = 2) and (item^.ColorOffset = 0) then
    color := $10
  else
    color := item^.coloroffset;

  left := item^.Left;
  if item^.flip = 1 then
    left := left - swap2(pword(integer(shape)+2)^);

  if item^.flip = 0 then
    FlipShap(shape, 0)
  else
    FlipShap(shape, 1);

  //backbuffer.SecondValue := $50;
  DrawIt(shape, nil, left, item^.Top, item^.Transparency, color, rect);

       

end;

procedure DumpBackTable;
var
  ctr: Integer;
begin
  for ctr := 0 to BackImgcount - 1 do
  begin
    if BackImgTable[ctr].PartFore = 0 then
    begin
      DrawBFItem(@BackImgTable[ctr]);
    end;
  end;

  for ctr := 0 to BackImgcount - 1 do
  begin
    if BackImgTable[ctr].PartFore <> 0 then
    begin
      DrawBFItem(@BackImgTable[ctr]);
    end;
  end;

end;
                             
procedure FinalDrawForeTable;
var
ctr: integer;
begin
  if (currentroom = 1) and (currentlevel.LevelNumber = 14) then
  begin
  for ctr := 0 to ForeImgCount - 1 do
  begin
    if ForeImgTable[ctr].ItemId = 25360 then
    begin
      DrawBFItem(@ForeImgTable[ctr]);
    end;
  end;

  for ctr := 0 to ForeImgcount - 1 do
  begin
    if ForeImgTable[ctr].ItemId <> 25360 then
    begin
      DrawBFItem(@ForeImgTable[ctr]);
    end;
  end;

  end
  else if (currentroom in [6..8]) and (currentlevel.LevelType = 6) then
  begin
  for ctr := 0 to ForeImgcount - 1 do
  begin
    if ((ForeImgTable[ctr].ItemId < 4133) or (ForeImgTable[ctr].ItemId > 4136)) and
    ((ForeImgTable[ctr].ItemId < 4177) or (ForeImgTable[ctr].ItemId > 4184)) then
    begin
      DrawBFItem(@ForeImgTable[ctr]);
    end;
  end;

  for ctr := 0 to ForeImgcount - 1 do
  begin
if ((ForeImgTable[ctr].ItemId >= 4133) and (ForeImgTable[ctr].ItemId <= 4136)) or
    ((ForeImgTable[ctr].ItemId >= 4177) and (ForeImgTable[ctr].ItemId <= 4184)) then
    begin
      DrawBFItem(@ForeImgTable[ctr]);
    end;
  end;
  end;
       

end;


procedure DumpForeTable;
var
ctr: integer;
begin
  if (currentlevel.LevelType = 6) and (currentroom in [1,6,7,8]) then
    FinalDrawForeTable
  else if (currentroom = 22) and (currentlevel.LevelNumber = 10) then
  begin
  for ctr := 0 to ForeImgcount - 1 do
  begin
    if ForeImgTable[ctr].ItemId = 25360 then
    begin
      DrawBFItem(@ForeImgTable[ctr]);
    end;
  end;

  for ctr := 0 to ForeImgcount - 1 do
  begin
    if ForeImgTable[ctr].ItemId <> 25360 then
    begin
      DrawBFItem(@ForeImgTable[ctr]);
    end;
  end;

  end
  else
  begin

  for ctr := 0 to ForeImgcount - 1 do
      DrawBFItem(@ForeImgTable[ctr]);
  end;

end;

procedure DumpTable(table: word);
begin
case table of
0: DumpBackTable;
3: DumpMidTable1;
1: DumpForeTable;
end;

end;

procedure DumpTables;
var
ctr: word;
row: pbyte;
clearbuffer: boolean;
begin
  SetForeColor(3);
  clearbuffer := inmap;
  if (currentlevel.levelnumber<>14) or (currentroom<>1) then
  begin
  row := backbuffer.Buffer;

  case currentlevel.LevelNumber of
    1: if currentroom in [6,7,8,9,13,14,17] then clearbuffer := true;
    2: if currentroom in [4,5] then clearbuffer := true;
    6: if currentroom in [2,10,11,14,15,24,26,28]  then clearbuffer := true;
    8: if currentroom in [7,15,26,27] then clearbuffer := true;
    9: if currentroom in [22,23]  then clearbuffer := true;
    10: if currentroom in [6,30,31]  then clearbuffer := true;
    11: if currentroom in [11,30]  then clearbuffer := true;
    13: if currentroom in [14,15,26] then clearbuffer := true;
    14: if currentroom in [9,10] then clearbuffer := true;
  end;
  
  if clearbuffer then
  begin
  for ctr := 1 to BackBuffer.Height do
  begin
  FillChar(row^, backbuffer.Width, 0); //BLEU!
  inc(row, backbuffer.Pitch);
  end;
  end;
  end;

  FillChar(backbuffer.SecondBuffer^, backbuffer.pitch * backbuffer.Height, 0);
  backbuffer.secondvalue := 0;

  //Peel
  DumpTable(0);
  DumpTable(3);
  DumpTable(1);

end;

procedure DumpMidTable1;
var
ctr:integer;
begin
  for ctr := 0 to MidImgCount1 - 1 do
      DrawMidItem(@MidImgTable1[ctr]);
end;

procedure DumpMidTable2;
var
ctr:integer;
begin
  for ctr := 0 to MidImgCount2 - 1 do
      DrawMidItem(@MidImgTable2[ctr]);
end;



end.
