unit uFinal;

interface

procedure DrawWink;
procedure DrawSpider;
procedure DrawCrystal;
procedure DrawGargoyle;
procedure DrawGeneric;
procedure TowerTopTemplateIn;
procedure TowerBottomTemplateIn;
procedure PrincessRoomTemplateIn;
procedure SpiderAndChessRoomTemplateIn;
procedure CrystalAndEscherRoomTemplateIn;


implementation

uses uImgTables, uGlobals, uMacTypes, uRect, uColorTables;

const

winkframes: array [0..4] of word = (0,1,1,0,0);
paw1frames: array [0..5] of word = (0,1,2,3,2,1);
paw2frames: array [0..5] of word = (4,5,6,7,6,5);
crystalframes: array [0..4] of word = (0,1,2,3,0);
crystalpos: array [0..8] of array[0..1] of smallint =
(
($53, $1D8),
($A7, $3B),
($A5, $82),
($BF, $C9),
($B1, $13D),
($BD, $163),
($1B, 1),
($11D, $D3),
($128, $193)
);
crystallayer: array [0..8] of word = (1,0,0,0,0,1,1,1,1);
gargoyleframes: array[0..6] of word = (2,1,2,3,1,2,0);
gargoylelayer: array[0..3] of word = (0,0,0,1);
gargoylepos: array[0..3] of array[0..1] of smallint = (
($93, $AC),
($CD, $D8),
($112, $061),
($112, $140)
);

procedure DrawWink;
var
backmasked: word;
begin
  backmasked := NextBFItem^.PartBack.Back1 and $1F;
  if (backmasked >= $C) and (NextBFItem^.layer = 11) and ((backmasked - $C) < 4) then
  begin
    dec(backmasked, $C);
    DrawCustomRoomImg(winkframes[backmasked]+3, 11);
  end;
  
  
end;

procedure DrawSpider;
var
paw1, paw2: word;
begin
  if NextBFItem^.Layer <> 11 then exit;
  if (NextBFItem^.PartBack.Back1 and 2040) = 0 then
  begin
    paw1 := 0;
    paw2 := 0;
  end
  else if (NextBFItem^.partback.Back1 and $800) <> 0 then
  begin
    paw1 := 0;
    paw2 := NextBFItem^.PartBack.back1 and 7;
  end
  else
  begin
    paw1 := NextBFItem^.PartBack.back1 and 7;
    paw2 := 0;
  end;
  DrawCustomRoomImg(paw1frames[paw1]+3, 11);
  DrawCustomRoomImg(paw2frames[paw2]+3, 11);

end;

procedure DrawCrystal;
var
back: word;
backmasked: smallint;
prevrect: TMacRect;
prevbottom: smallint;
prevleft: smallint;
frame: word;
begin
  if NextBFItem^.Layer <> 1 then exit;
  back := NextBFItem^.PartBack.back1;
  if (back and $800) = 0 then exit;
  backmasked := ((back and $7F0) shr 4) - 1;
  if backmasked < 0 then exit;
  frame := crystalframes[backmasked];
  prevrect := custompieces^.Content[frame+8].rect;
  prevbottom := custompieces^.Content[frame+8].bottom;
  prevleft :=  custompieces^.Content[frame+8].left;
  custompieces^.Content[frame+8].bottom := crystalpos[back and $F][0];
  custompieces^.Content[frame+8].left := crystalpos[back and $F][1];
  OffsetRect(custompieces^.Content[frame+8].rect, crystalpos[back and $F][1], crystalpos[back and $F][0]);
  custompieces^.Content[frame+8].layer := crystallayer[back and $F];
  DrawCustomRoomImg(frame+8, crystallayer[back and $F]);
  custompieces^.Content[frame+8].layer := 11;
  custompieces^.Content[frame+8].rect := prevrect;
  custompieces^.Content[frame+8].bottom := prevbottom;
  custompieces^.Content[frame+8].left := prevleft;


end;

procedure DrawGargoyle;
var
back: word;
backmasked1: smallint;
prevrect: TMacRect;
prevbottom: smallint;
prevleft: smallint;
frame: word;
backmasked2: word;
begin
  if NextBFItem^.Layer <> 1 then exit;
  back := NextBFItem^.PartBack.back1;
  if (back and $800) = 0 then exit;
  backmasked1 := ((back and $7F0) shr 4) - 1;
  if backmasked1 < 0 then exit;
  backmasked2 := back and $F;

  frame := gargoyleframes[backmasked1];
  inc(frame, 2);
  if backmasked2 <> 0 then
    inc(frame, 4);
  prevrect := custompieces^.Content[frame].rect;
  custompieces^.Content[frame].bottom := gargoylepos[backmasked2][0];
  custompieces^.Content[frame].left := gargoylepos[backmasked2][1];
  OffsetRect(custompieces^.Content[frame].rect, gargoylepos[backmasked2][1], gargoylepos[backmasked2][0]);
  custompieces^.Content[frame+8].layer := gargoylelayer[frame];
  DrawCustomRoomImg(frame, gargoylelayer[frame]);
  custompieces^.Content[frame].layer := 11;
  custompieces^.Content[frame].rect := prevrect;
  custompieces^.Content[frame].bottom := 0;
  custompieces^.Content[frame].left := 0;


end;

procedure DrawGeneric;
begin
  if (currentroom = 6) and (currentlevel.LevelType = 6) and ((NextBFItem^.PartBack.Back1 and $1000) <> 0) then
    DrawCrystal;
  if (currentroom in [7,8]) and (currentlevel.leveltype = 6) and ((NextBFItem^.partback.back1 and $1000) <> 0) then
    DrawGargoyle;

end;

procedure TowerTopTemplateIn;
var
row: pbyte;
ctr: integer;
begin
  PopSetPalette(3500, $40);
  row := backbuffer.Buffer;
  for ctr := 1 to BackBuffer.Height do
  begin
  FillChar(row^, backbuffer.Width, $40); //BLEU!
  inc(row, backbuffer.Pitch);
  end;
end;

procedure TowerBottomTemplateIn;
begin
  PopSetPalette(3500, $40);
end;

procedure PrincessRoomTemplateIn;
begin
  PopSetPalette(3503, $40);
  ResetStandardColors;
end;

procedure SpiderAndChessRoomTemplateIn;
begin
  PopSetPalette(3501, $40);
  if (currentroom = 4) and (currentlevel.leveltype = 6) then
  begin
    PopSetPalette(4077, $D0);
    PopSetPalette(1006, $F0);
 end
 else if (currentroom = 3) and (currentlevel.leveltype = 6) then
 begin
   PopSetPalette(3000, $E0);
 end;

end;

procedure CrystalAndEscherRoomTemplateIn;
begin
  PopSetPalette(3502, $40);
  PopSetPalette(1006, $F0);
  PopSetPalette(25008, $20);
  if currentroom = 7 then
    PopSetPalette(3000, $E0)
  else if currentroom = 8 then
    PopSetPalette(3000, $E0);

end;


end.
