unit uFrames;

interface

procedure ConvertKidFrames;
procedure ConvertKidAFrames;
procedure ConvertOppFrames;
procedure ConvertOppAFrames;
procedure ConvertHeadMoves;
procedure RefreshFrames;
procedure RefreshBlockX;
function GetAFrameDelta: smallint;

implementation

uses uGlobals, uSwapper, uChars;

procedure ConvertKidFrames;
var
  ctr: Integer;
begin
  for ctr := 0 to length(kidframes) - 1 do
  begin
    kidframes[ctr].ImgID := swap2(kidframes[ctr].ImgID);
    kidframes[ctr].AFrame := swap2(kidframes[ctr].AFrame);
    kidframes[ctr].DeltaX := swap2(kidframes[ctr].DeltaX);
    kidframes[ctr].DeltaY := swap2(kidframes[ctr].DeltaY);
    kidframes[ctr].Flags := swap2(kidframes[ctr].Flags);    
  end;
end;

procedure ConvertKidAFrames;
var
  ctr: Integer;
begin
  for ctr := 0 to length(kidaframes) - 1 do
  begin
    kidaframes[ctr].AFrmType := swap2(kidaframes[ctr].AFrmType);
    kidaframes[ctr].ImgID := swap2(kidaframes[ctr].ImgID);
    kidaframes[ctr].DeltaX := swap2(kidaframes[ctr].DeltaX);
    kidaframes[ctr].DeltaY := swap2(kidaframes[ctr].DeltaY);
  end;
end;

procedure ConvertOppFrames;
var
  ctr: Integer;
begin
  for ctr := 0 to length(oppframes) - 1 do
  begin
    oppframes[ctr].ImgID := swap2(oppframes[ctr].ImgID);
    oppframes[ctr].AFrame := swap2(oppframes[ctr].AFrame);
    oppframes[ctr].DeltaX := swap2(oppframes[ctr].DeltaX);
    oppframes[ctr].DeltaY := swap2(oppframes[ctr].DeltaY);
    oppframes[ctr].Flags := swap2(oppframes[ctr].Flags);    
  end;

end;

procedure ConvertOppAFrames;
var
  ctr: Integer;
begin
  for ctr := 0 to length(oppaframes) - 1 do
  begin
    oppaframes[ctr].AFrmType := swap2(oppaframes[ctr].AFrmType);
    oppaframes[ctr].ImgID := swap2(oppaframes[ctr].ImgID);
    oppaframes[ctr].DeltaX := swap2(oppaframes[ctr].DeltaX);
    oppaframes[ctr].DeltaY := swap2(oppaframes[ctr].DeltaY);
  end;
end;

procedure ConvertHeadMoves;
var
  ctr: Integer;
begin
  for ctr := 0 to length(headmoves) - 1 do
  begin
    headmoves[ctr].DeltaX := swap2(headmoves[ctr].DeltaX);
    headmoves[ctr].DeltaY := swap2(headmoves[ctr].DeltaY);
  end;
end;

procedure RefreshFrames;
var
diff : smallint;
begin
  diff := 0;
  case ActiveChar.CharType of
  0,1,6:
  begin
    //kid
    CharFrame := KidFrames[ActiveChar.Posn];
    CharAFrame := KidAFrames[CharFrame.AFrame];
  end;  
  2,4,10,12:
  begin
    if (ActiveCHar.Posn in [102..106]) then
      diff := 70;
    CharFrame := OppFrames[ActiveChar.Posn - $95 + diff];
    CharAFrame := OppAFrames[CharFrame.AFrame];
  end;
  3,5,9:
  begin
    //rien...
  end;
  7,11:
  begin
    CharFrame := OppFrames[ActiveChar.Posn - $95 + diff];
    CharAFrame := OppAFrames[CharFrame.AFrame];
  end;
  8: begin
    if ActiveCHar.Posn < 182 then
      diff := 43;
    CharFrame := OppFrames[ActiveChar.Posn - $95 + diff];
    CharAFrame := OppAFrames[CharFrame.AFrame];
  end;
  end;
end;

procedure RefreshBlockX;
begin
  ActiveChar.BlockX := ((AddCharX(CharFrame.DeltaX - (CharFrame.Flags and $3F)) - 22) div 51) - 4;
end;

function GetAFrameDelta: smallint;
begin
  Result := 0;
  if ActiveChar.Sword <> 1 then exit;
  if ActiveChar.CharType in [7,8] then exit;
  if CharAFrame.AFrmType = 0 then exit;
  Result := CharAFrame.DeltaX - 3;
  if Result < 0 then Result := 0;
end;

end.
