unit uLevel;

interface

procedure LoadLevelMap(level: word);
procedure ConvertLevel;
procedure ResetLevel;
procedure OpenLevelRsrcFile(newtype: word; prevtype: word);
procedure UnloadFrom(index: word);
procedure UnloadLevel(index: word);
procedure LoadLevel(index: word);

implementation
uses uResources, uGlobals, uMacFile, uPop2Types, uSwapper, uRoomUtil,
uCustom, uShapeSets, uColorTables, uPieces;

procedure LoadLevelMap(level: word);
var
res: PResource;
resfile: PResFile;
begin
  resfile := PoPCurResFile;
  PopUseResFile(resPrince);
  res := PoPGetResource('LEVL', level - 1 + 2000);
  if res <> nil then
  begin
    move(res^.data^, currentlevel, sizeof(TLevel));
    ConvertLevel;
  end;
  PopUseResFile(resfile);
end;

procedure ConvertLevel;
var
  ctr: Integer;
  ctr2: Integer;
begin
  for ctr := 0 to 31 do
  begin
    for ctr2 := 0 to 29 do
    begin
      currentlevel.ForeTables[ctr][ctr2] := swap2(currentlevel.ForeTables[ctr][ctr2]);
      currentlevel.BackTables[ctr][ctr2].Back1 := swap2(currentlevel.BackTables[ctr][ctr2].Back1);
      currentlevel.BackTables[ctr][ctr2].Back2 := swap2(currentlevel.BackTables[ctr][ctr2].Back2);
    end;
    currentlevel.Relations[ctr].Left := swap2(currentlevel.Relations[ctr].Left);
    currentlevel.Relations[ctr].Right := swap2(currentlevel.Relations[ctr].Right);
    currentlevel.Relations[ctr].Up := swap2(currentlevel.Relations[ctr].Up);
    currentlevel.Relations[ctr].Down := swap2(currentlevel.Relations[ctr].Down);

    currentlevel.RoomGuards[ctr].Count := swap2(currentlevel.RoomGuards[ctr].Count);
    for ctr2 := 0 to 4 do
    begin
      currentlevel.RoomGuards[ctr].Guards[ctr2].Cell := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].Cell);
      currentlevel.RoomGuards[ctr].Guards[ctr2].Left := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].Left);
      currentlevel.RoomGuards[ctr].Guards[ctr2].Face := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].Face);
      currentlevel.RoomGuards[ctr].Guards[ctr2].m_6 := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].m_6);
      currentlevel.RoomGuards[ctr].Guards[ctr2].Seq := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].Seq );
      currentlevel.RoomGuards[ctr].Guards[ctr2].SeqPos := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].SeqPos );
      currentlevel.RoomGuards[ctr].Guards[ctr2].m_C := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].m_C);
      currentlevel.RoomGuards[ctr].Guards[ctr2].m_E := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].m_E);
      currentlevel.RoomGuards[ctr].Guards[ctr2].Sword := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].Sword);
      currentlevel.RoomGuards[ctr].Guards[ctr2].Strength := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].Strength);
      currentlevel.RoomGuards[ctr].Guards[ctr2].m_14 := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].m_14);
      currentlevel.RoomGuards[ctr].Guards[ctr2].m_16 := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].m_16);
      currentlevel.RoomGuards[ctr].Guards[ctr2].GuardType := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].GuardType);
      currentlevel.RoomGuards[ctr].Guards[ctr2].MaxLives := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].MaxLives);
      currentlevel.RoomGuards[ctr].Guards[ctr2].m_1C := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].m_1C);
      currentlevel.RoomGuards[ctr].Guards[ctr2].m_1E := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].m_1E);
      currentlevel.RoomGuards[ctr].Guards[ctr2].m_20 := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].m_20);
      currentlevel.RoomGuards[ctr].Guards[ctr2].m_22 := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].m_22);
      currentlevel.RoomGuards[ctr].Guards[ctr2].m_24 := swap2(currentlevel.RoomGuards[ctr].Guards[ctr2].m_24);
    end;

  end;
  for ctr := 0 to 255 do
  begin
    currentlevel.Links[ctr].Room := swap2(currentlevel.Links[ctr].Room);
    currentlevel.Links[ctr].Cell := swap2(currentlevel.Links[ctr].Cell);
    currentlevel.Links[ctr].Timer := swap2(currentlevel.Links[ctr].Timer);
    currentlevel.Links[ctr].Prev := swap2(currentlevel.Links[ctr].Prev);
    currentlevel.Links[ctr].Next := swap2(currentlevel.Links[ctr].Next);
  end;

  currentlevel.LevelNumber := swap2(currentlevel.LevelNumber);
  currentlevel.LevelType:= swap2(currentlevel.LevelType);
  currentlevel.MaxRooms := swap2(currentlevel.MaxRooms);
  currentlevel.InitialCell := swap2(currentlevel.InitialCell);
  currentlevel.InitialRoom := swap2(currentlevel.InitialRoom);
  currentlevel.InitialFacing := swap2(currentlevel.InitialFacing);
  currentlevel.OpponentType := swap2(currentlevel.OpponentType);

end;

procedure ResetLevel;
var
  ctr, ctr2: Integer;
begin
  for ctr := 1 to currentlevel.MaxRooms do
  begin
    CalcBlue(ctr);
    leftroom := currentlevel.relations[ctr - 1].Left;
    rightroom := currentlevel.relations[ctr - 1].Right;
    for ctr2 := 0 to 29 do
    begin
      InitState(ctr2);
    end;

      

  end;

end;

procedure OpenLevelRsrcFile(newtype: word; prevtype: word);
begin
PopUseResFile(levelresources[currentlevel.LevelType]);
end;

procedure UnloadFrom(index: word);
var
ctr: word;
begin
  //ClearPeelList;
  if index < 5 then
  begin
    for ctr := index to 4 do
      UnloadSet(ctr);
  end;
  if index <= 4 then
  begin
    if custompieces <> nil then
      ClearCustomShapesTable;
    if currentlevel.LevelType = 6 then
      UnloadFlameShapes;
  end;
  
end;

procedure UnloadLevel(index: word);
begin
  UnloadFrom(index);
  //bout skipp
  if (index <= 3) and (length(oppframes) > 0) then
  begin
    SetLength(oppframes, 0);
    SetLength(headmoves, 0);
    if resOpp <> nil then
      CloseResFile(resOpp);
    resOpp := nil;
    currentopptype := -1;
  end;
  if (index <= 2) and (length(kidframes) > 0) then
    SetLength(kidframes, 0);
  if index <= 0 then
  begin
    SetLength(kidaframes, 0);
    SetLength(oppaframes, 0);
  end;

  UnloadPiece;
  ClearCustomShapesTable;
end;

procedure LoadLevel(index: word);
begin
  UnloadLevel(3);
  LoadLevelMap(index);
  ResetStandardColors;
  //LoadCodeOverlays;
  LoadFlaskSet;
  //OpenLevelRsrcFile(currentlevel.LevelType, 0);
  LoadBGSet(true);

  LoadKidSet;
  LoadOppSet(currentlevel.OpponentType);

  GetSwordType;
  LoadSwordSet(SwordType);

  //skip..
  PopUseResFile(levelresources[currentlevel.leveltype]);
  LoadPiece;
  PopUseResFile(resKid);

  SetKidPalette(currentlevel.LevelType);

  //if currentlevel.LevelType = 1 then
  //sub_3AA dans desert.

  //SetPrinceLevelSpecPtrs(currentlevel.LevelType);

end;

end.
