unit uLevelDraw;

interface

procedure DrawItem(itemtype: word);
procedure InitDraws;
function IsAssigned(itemtype:word):boolean;

implementation

uses uGlobals, uRoofTops, uPop2Types, uDesert, uCaves, uShared, uRuins, uTemple, uFinal;

var
DrawFuncs: array[1..6] of array[0..49] of procedure;

procedure DrawItem(itemtype: word);
begin
if assigned(DrawFuncs[currentlevel.LevelType][itemtype]) then
  DrawFuncs[currentlevel.LevelType][itemtype];
end;

function IsAssigned(itemtype:word):boolean;
begin
Result := assigned(DrawFuncs[currentlevel.LevelType][itemtype]);
end;

procedure InitDraws;
begin
  DrawFuncs[5][CELL_EMPTY] := uRoofTops.DrawEmpty;
  DrawFuncs[5][CELL_FLOOR] := uRoofTops.DrawFloor;
  DrawFuncs[5][CELL_WALL] := uRoofTops.DrawWall;
  DrawFuncs[5][CELL_WATERPILLAR] := uRoofTops.DrawPillar;
  DrawFuncs[5][CELL_BOAT] := uRooftops.DrawShip;
  DrawFuncs[5][CELL_WINDOW] := uRoofTops.DrawGlass;

  DrawFuncs[1][CELL_DOOR] := uDesert.DrawDoor;
  DrawFuncs[1][CELL_ROCK] := uDesert.DrawRock;
  DrawFuncs[1][CELL_PLANK] := uDesert.DrawPlank;
  DrawFuncs[1][CELL_SINKABLE] := uDesert.DrawSinkable;

  DrawFuncs[3][CELL_EMPTY] := uCaves.DrawEmpty;
  DrawFuncs[3][CELL_FLOOR] := uCaves.DrawFloor;
  DrawFuncs[3][CELL_SPIKES] := uCaves.DrawSpikes;
  DrawFuncs[3][CELL_PILLAR] := uCaves.DrawPost;
  DrawFuncs[3][CELL_DOOR] := uCaves.DrawGate;
  DrawFuncs[3][CELL_BOTTOMPILLAR] := uCaves.DrawPillarBottom;
  DrawFuncs[3][CELL_TOPPILLAR] := uCaves.DrawPillarTop;
  DrawFuncs[3][CELL_POTION] := uShared.DrawPotion;
  DrawFuncs[3][CELL_LOOSE] := uCaves.DrawLoose;
  DrawFuncs[3][CELL_DEBRIS] := uCaves.DrawDebris;
  DrawFuncs[3][CELL_EXITLEFT] := uCaves.DrawDoorLeft;
  DrawFuncs[3][CELL_EXITRIGHT] := uCaves.DrawDoorRight;
  DrawFuncs[3][CELL_CARPET] := uCaves.DrawCarpet;
  DrawFuncs[3][CELL_TORCH] := uCaves.DrawTorch;
  DrawFuncs[3][CELL_WALL] := uCaves.DrawWall;
  DrawFuncs[3][CELL_LAVALEFT] := uCaves.DrawLavaLeft;
  DrawFuncs[3][CELL_LAVARIGHT] := uCaves.DrawLavaRight;
  DrawFuncs[3][CELL_CAVEBARS] := uCaves.DrawBars;
  DrawFuncs[3][CELL_TORCHDEBRIS] := uCaves.DrawTorchDebris;
  DrawFuncs[3][CELL_DART] := uCaves.DrawDart;
  DrawFuncs[3][CELL_PRESSURE] := uCaves.DrawPressure;
  DrawFuncs[3][CELL_BRIDGE] := uCaves.DrawBridge;

  DrawFuncs[4][CELL_EMPTY] := uRuins.DrawRuinEmpty;
  DrawFuncs[4][CELL_FLOOR] := uRuins.DrawFloor;
  DrawFuncs[4][CELL_PILLAR] := uRuins.DrawPosts;
  DrawFuncs[4][CELL_DOOR] := uRuins.DrawGate;
  DrawFuncs[4][CELL_RAISED] := uRuins.DrawUpPlate;
  DrawFuncs[4][CELL_LOWERED] := uRuins.DrawDownPlate;
  DrawFuncs[4][CELL_TUNNEL] := uRuins.DrawCrevice;
  DrawFuncs[4][CELL_BOTTOMPILLAR] := uRuins.DrawPillarBottom;
  DrawFuncs[4][CELL_TOPPILLAR] := uRuins.DrawPillarTop;
  DrawFuncs[4][CELL_POTION] := uShared.DrawPotion;
  DrawFuncs[4][CELL_LOOSE] := uRuins.DrawLoose;
  DrawFuncs[4][CELL_SLICERLEFT] := uShared.DrawScythe1;
  DrawFuncs[4][CELL_SLICERRIGHT] := uShared.DrawScythe2;
  DrawFuncs[4][CELL_DEBRIS] := uRuins.DrawRubble;
  DrawFuncs[4][CELL_DROP] := uRuins.DrawFloor;
  DrawFuncs[4][CELL_EXITLEFT] := uRuins.DrawExit1;
  DrawFuncs[4][CELL_EXITRIGHT] := uRuins.DrawExit2;
  DrawFuncs[4][CELL_WALL] := uRuins.DrawWall;
  DrawFuncs[4][CELL_SKELETON] := uRuins.DrawSkeleton;
  DrawFuncs[4][CELL_SWORD] := uShared.DrawSword;

  DrawFuncs[2][CELL_EMPTY] := uTemple.DrawEmpty;
  DrawFuncs[2][CELL_FLOOR] := uTemple.DrawFloor;
  DrawFuncs[2][CELL_SPIKES] := uTemple.DrawSpikes;
  DrawFuncs[2][CELL_PILLAR] := uTemple.DrawPosts;
  DrawFuncs[2][CELL_DOOR] := uTemple.DrawGate;
  DrawFuncs[2][CELL_RAISED] := uTemple.DrawUpPlate;
  DrawFuncs[2][CELL_LOWERED] := uTemple.DrawDownPlate;
  DrawFuncs[2][CELL_BOTTOMPILLAR] := uTemple.DrawPillarBottom;
  DrawFuncs[2][CELL_TOPPILLAR] := uTemple.DrawPillarTop;
  DrawFuncs[2][CELL_POTION] := uShared.DrawPotion;
  DrawFuncs[2][CELL_LOOSE] := uTemple.DrawLoose;
  DrawFuncs[2][CELL_SLICERLEFT] := uShared.DrawScythe1;
  DrawFuncs[2][CELL_SLICERRIGHT] := uShared.DrawScythe2;
  DrawFuncs[2][CELL_DEBRIS] := uTemple.DrawRubble;
  DrawFuncs[2][CELL_EXITLEFT] := uTemple.DrawExit1;
  DrawFuncs[2][CELL_EXITRIGHT] := uTemple.DrawExit2;
  DrawFuncs[2][CELL_TORCH] := uTemple.DrawTorch;
  DrawFuncs[2][CELL_WALL] := uTemple.DrawWall;
  DrawFuncs[2][CELL_SLIDEWALL] := uTemple.DrawWall;
  DrawFuncs[2][CELL_FLIP] := uTemple.DrawFlip;
  DrawFuncs[2][CELL_TORCHDEBRIS] := uTemple.DrawTorchDebris;
  DrawFuncs[2][CELL_FLAME] := uTemple.DrawFlame;

  DrawFuncs[6][CELL_EMPTY] := uFinal.DrawGeneric;
  DrawFuncs[6][CELL_FLOOR] := uFinal.DrawGeneric;
  DrawFuncs[6][CELL_POTION] := uShared.DrawPotion;
  DrawFuncs[6][CELL_WALL] := uFinal.DrawGeneric;
  DrawFuncs[6][CELL_WINK] := uFinal.DrawWink;
  DrawFuncs[6][CELL_SPIDER] := uFinal.DrawSpider;
  DrawFuncs[6][CELL_CRYSTAL] := uFinal.DrawCrystal;
  DrawFuncs[6][CELL_GARGOYLE] := uFinal.DrawGargoyle;



end;

initialization

InitDraws;

end.
