unit uPop2Types;

interface

uses uMacTypes;

type

TBackPair = packed record
  Back1: word;
  Back2: word;
end;

TLink = packed record
  Room: smallint;
  Cell: word;
  Timer: word;
  prev: smallint;
  Next: smallint;
end;

TRelation = packed record
  Left: smallint;
  Right: smallint;
  Up: smallint;
  Down: smallint;
end;

PForeEntry =  ^TForeEntry;
TForeEntry = array[0..29] of word;

PBackEntry = ^TBackEntry;
TBackEntry = array [0..29] of TBackPair;

TImmediate = record
  Fore: Word;
  Back: TBackPair;
end;

PStaticGuard = ^TStaticGuard;
TStaticGuard = packed record
  Cell: Word;
  Left: SmallInt;
  Face: SmallInt;
  m_6: word;
  Seq: Word;
  SeqPos: Word;
  m_C: Word;
  m_E: Word;
  Sword: Word;
  Strength: Word;
  m_14: Word;
  m_16: Word;
  GuardType: word;
  MaxLives: Word;
  m_1C: smallint;
  m_1E: smallint;
  m_20: Word;
  m_22: smallint;
  m_24: WOrd;
end;

TObj = record
  X: smallint;
  Y: smallint;
  ImgSet: smallint;
  ImgID: smallint;
  Posn: word;
  Face: smallint;
  ObjType: word;
  ColorOffset: word;
  Rect: TMacRect;
  Attached: smallint;
  Idx: word;
end;


PRoomGuard = ^TRoomGuard;
TRoomGuard = packed record
  Count: Word;
  Guards: array[0..4] of TStaticGuard;
end;


TLevel = packed record
ForeTables: array[0..31] of TForeEntry; //@0
BackTables: array[0..31] of TBackEntry; //@780
Links: array[0..255] of TLink; //1680
Relations: array [0..31] of TRelation;
MaxRooms: word;
MAC1: array[0..3] of char;
LevelType: word;
M_2188: Word;
LevelNumber: word;
m_218C: word;
m_218E: word;
m_2190: word;
m_2192: word;
m_2194: word;
m_2196: byte;
HasFlask: boolean;
InitialRoom: word;
InitialCell: word;
InitialFacing: smallint;
m_219E: word;
m_21A0: word;
m_21A2: word;
OpponentType: word;
RoomGuards: array[0..31] of TRoomGuard; //@21A6
{
@0 = foretable[32](60)
@780 = backtable[32](120)
@1680 = doors[256](10)  -- room(w)cell(w)timer(w)prev(w)next(w)
@2080 = relations[32](8)  -- gauche, droite, haut, bas
@2180 = (w)
@2186 = leveltype(w)
@218A = levelnumber(w)
@2197 = (b)
@2198 = initialroom(w)
@219A = initialcell(w)
@219C = (w)
@21A4 = opponenttype(w)
@21A6 = static[32](192)
@39CA = dynamic[32](68) -- ?
@424A = ambient[32](60)
}
end;

PShapeListEntry = ^TShapeListEntry;
TShapeListEntry = packed record
shape: pointer; //@6
end;

PShapeList = ^TShapeList;
TShapeList = packed record
  Data: pointer;
  ListID: smallint;
  NbItems: word;
  Content: array[0..0] of TShapeListEntry;
end;

PCustomPiece = ^TCustomPiece;
TCustomPiece = record
index: word;
bottom: smallint;
left: smallint;
layer: word;
transparent: word;
shapeid: smallint;
shape: pointer;
rect: TMacRect;
var_1A: smallint;
end;

PCustomPieces = ^TCustomPieces;
TCustomPieces = record
ID: word;
FirstID: word;
MaxID: word;
Precalculated: word;
NBItems: word;
Var_E: smallint;
Content: array of TCustomPiece;
end;

PFrameEntry = ^TFrameEntry;
TFrameEntry = packed record
ImgID: smallint;
AFrame: smallint;
DeltaX: smallint;
DeltaY: smallint;
Flags: smallint;
end;

PAFrameEntry = ^TAFrameEntry;
TAFrameEntry = packed record
  AFrmType: smallint;
  ImgID: smallint;
  DeltaX: smallint;
  DeltaY: smallint;
end;

PHeadMove = ^THeadMove;
THeadMove = packed record
  DeltaX: smallint;
  DeltaY: smallint;
end;

PCharInfos = ^TCharInfos;
TCharInfos = record
Index: Word;
X: smallint;
Y: smallint;
Face: smallint;
Posn: word;
BlockX: smallint;
BlockY: smallint;
SeqID: word;
SeqPos: word;
Action: word;
Room: word;
CharType: word;
Rect: TMacRect;
Sword: smallint;
ColorOffset: word;
Status: smallint;
Death: smallint;
end;

//CellTypes

const
CELL_EMPTY = 0;
CELL_FLOOR = 1;
CELL_SPIKES = 2;
CELL_PILLAR = 3;
CELL_DOOR = 4;
CELL_RAISED = 5;
CELL_LOWERED = 6;
CELL_TUNNEL = 7;
CELL_BOTTOMPILLAR = 8;
CELL_TOPPILLAR = 9;
CELL_POTION = 10;
CELL_LOOSE = 11;
CELL_SLICERLEFT = 12;
CELL_SLICERRIGHT = 13;
CELL_DEBRIS = 14;
CELL_DROP = 15;
CELL_EXITLEFT = 16;
CELL_EXITRIGHT = 17;
CELL_CARPET = 18;
CELL_TORCH = 19;
CELL_WALL = 20;
CELL_SKELETON = 21;
CELL_SWORD = 22;
CELL_LAVALEFT = 23;
CELL_LAVARIGHT = 24;
CELL_SLIDEWALL = 25;
CELL_FLIP = 26;
CELL_CAVEBARS = 27;
CELL_ROCK = 28; //animation d'eau sur la roche dans desert
CELL_PLANK = 29; //animation sur la planche dans desert
CELL_SINKABLE = 30; //plateformes dans desert
CELL_WINK = 31; //clin d'oeil dans le final
CELL_TORCHDEBRIS = 32;
CELL_DART = 33;
CELL_PRESSURE = 34;
CELL_23 = 35;
CELL_24 = 36;
CELL_25 = 37;
CELL_26 = 38;
CELL_27 = 39;
CELL_SPIDER = 40;
CELL_CRYSTAL = 41;
CELL_GARGOYLE = 42;
CELL_FLAME = 43;
CELL_BRIDGE = 44;
CELL_WATERPILLAR = 47;
CELL_BOAT = 48; //bateau au 1er
CELL_WINDOW = 49; //fenetre au 1er,



(*
Roof:
00 00 1F 3A -- empty
00 00 1F 32 -- floor
00 00 00 00 -- spikes
00 00 00 00 -- pillar
00 00 00 00 -- door
00 00 00 00 -- raised
00 00 00 00 -- lowered
00 00 00 00 -- tunnel
00 00 00 00 -- bottompillar
00 00 00 00 -- toppillar
00 00 00 00 -- potion
00 00 00 00 -- loose
00 00 00 00 -- slicerleft
00 00 00 00 -- slicerright
00 00 00 00 -- debris
00 00 00 00 -- drop
00 00 00 00 -- exitleft
00 00 00 00 -- exitright
00 00 00 00 -- carpet
00 00 00 00 -- torch
00 00 1F 2A -- wall
00 00 00 00 -- skeleton
00 00 00 00 -- sword
00 00 00 00 -- lavaleft
00 00 00 00 -- lavaright
00 00 00 00 -- slidewall
00 00 00 00 -- flip
00 00 00 00 -- 1B
00 00 00 00 -- torchdebris
00 00 00 00 -- exittopleft
00 00 00 00 -- pressure
00 00 00 00 -- exittopright
00 00 00 00 -- dart
00 00 00 00 -- flame
00 00 00 00 -- bridge
00 00 00 00 
00 00 00 00 
00 00 00 00 
00 00 00 00 
00 00 00 00 
00 00 00 00 
00 00 00 00 
00 00 00 00 
00 00 00 00 
00 00 00 00 
00 00 00 00 
00 00 00 00 
00 00 1F 92 
00 00 1F AA
00 00 1F 82
00 00 00 00
00 00 00 00


Caverns:


00 00 01 EA -- potion

00 00 00 00
00 00 00 00
00 00 00 00
00 00 00 00
00 00 0B D2 -- pressure
00 00 00 00    35
00 00 00 00    36
00 00 00 00    37
00 00 00 00    38
00 00 00 00    39
00 00 00 00    40
00 00 00 00    41
00 00 00 00    42
00 00 00 00    43
00 00 0C BA -- bridge
        *)

implementation

end.
