unit uRooftops;

interface

procedure DrawEmpty;
procedure DrawFloor;
procedure DrawWall;
procedure DrawPillar;
procedure DrawShip;
procedure DrawGlass;

procedure DrawBackWall;
procedure DrawEdge;

function IsOnTop: boolean;
function DrawPillarInBack(col: smallint; row: smallint): boolean;
function DrawLedgeInBack(backtype: word; col: smallint; row: smallint): boolean;

implementation

uses uImgTables, uGlobals, uCellUtil, uMacTypes, Math, uRect, uRoomUtil;

const
backwall: array [0..46] of word =
(
0,0,0,0,0,3,2,0,0,1,0,0,2,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,1,0,2,1,0,0,0,0,0,0,0,0,3,2,0,3,2
);

walledgelayers: array [0..14] of byte = (1,5,5,5,1,1,1,1,1,1,5,8,4,3,2);

walledgepos: array [0..10] of array [0..2] of smallint = (
(59, 47, -56),
(60, 00, 0),
(61, 48, -7),
(62, 00, -42),
(63, 35, -88),
(64, 47, -85),
(65, 45, -18),
(66, 46, -12),
(67, 46, -21),
(68, 48, 0),
(121, 38, -88)
);

colright: array [-1..10] of smallint = (
$000,
$033,
$066,
$099,
$0CC,
$0FF,
$132,
$165,
$198,
$1CB,
$1FE,
$231);

pillarrect1: TMacRect = (top: $68; left: $D; bottom: $C4; right: $2B);
pillarrect2: TMacRect = (top: $4B; left: $34; bottom: $A7; right: $52);
glassrect: TMacRect = (top: $28; left: $A; bottom: $70; right: $56);

glassindexes: array [0..$E] of word = (8, 4, 3, 2, 1, 5, 6, 7, 6, 5, 0, 1, 2, 3, 4);
glasstop: array [0..8] of smallint = ($13, $13, $E, $A, $A, $13, $13, $13, $B);
glassleft: array[0..8] of smallint = (-15, -15, -13, -14, -16, -15, -16, -16, -18);

procedure DrawEmpty;
var
shoulddraw: boolean;
begin
  if NextBFItem^.layer = 0 then
  begin
    shoulddraw := false;
    if drawingrow = NextBFItem^.PartRow  then
    shoulddraw := true
    else
    begin
      if NextBFItem^.PartRow = (drawingrow + 1) then
        shoulddraw := VisibleAbovePiece(NextBFItem^.PartCol, NextBFItem^.PartRow);
    end;
    if not shoulddraw then
    begin
      if (drawingrow = -1) and IsSpace(os_fore) then
        shoulddraw := true;
    end;
    if shoulddraw then
      DrawBackWall;
  end;
  DrawEdge;
  
end;

procedure DrawFloor;
var
oldclip: TMacRect;
shoulddraw: boolean;
lastitem: word;
right: smallint;
bf: PBFImgEntry;
layer: word;
begin
shoulddraw := false;
oldclip := drawingrect;
layer := NextBFItem^.Layer;
case NextBFItem^.Layer of
0: begin
  DrawBackWall;
  if (currentlevel.leveltype <> 5) or (currentroom in [15, 16, 19])  then
  begin
    if (NextBFItem^.PartBack.Back1 and $F) <> 0 then
    begin
      NextBFItem^.ItemID := 114;
      NextBFItem^.Left := 51;
      NextBFItem^.Top := -28;
      shoulddraw := true;
    end;
  end;
end;
1: begin
  if (currentlevel.leveltype <> 5) or (currentroom in [15, 16, 19])  then
  begin
    if (NextBFItem^.PartBack.Back1 and $F) <> 0 then
    begin
      NextBFItem^.ItemID := 113;
      NextBFItem^.Left := 0;
      NextBFItem^.Top := 0;
      shoulddraw := true;
    end;
  end
  else
  begin
    //if (NextBFItem^.PartBack.Back1 and $F) <> 0 then
    //begin
      NextBFItem^.ItemID := 51 + (NextBFItem^.PartBack.Back1 and $F);
      NextBFItem^.Left := 0;
      NextBFItem^.Top := 0;
      shoulddraw := true;
    //end;

  end;
  if shoulddraw then
  begin
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(1);
    shoulddraw := false;
  end;
  if (currentlevel.LevelType = 5) and not (currentroom in [15, 16, 19]) and
  IsSpace(PieceRightId(NextBFItem^.PartCol, NextBFItem^.PartRow)) and
  not DrawLedgeInBack((NextBFItem^.PartBack.Back1 and $F), NextBFItem^.PartCol, NextBFItem^.PartRow) then
  begin
    NextBFItem^.layer := 2;
  if IsOnTop then
  begin
    if IsSpace(PieceRightId(NextBFItem^.PartCol, NextBFItem^.PartRow)) then
    begin
      NextBFItem^.ItemID := Min(47+(NextBFItem^.PartBack.Back1 and $F), 50);
      NextBFItem^.Left := 51;
      NextBFItem^.Top := 0;
      shoulddraw := true;
    end
    else
      DrawEdge;
  end
  else
  begin
      NextBFItem^.ItemID := 112;
      NextBFItem^.Left := 0;
      NextBFItem^.Top := 0;
    shoulddraw := true;
  end;
  if shoulddraw then
  begin
    if NextBFItem^.Layer = 5 then
    begin
      bf := NextBFItem;
      ResetNextBFItem(5);
      TransferBFItemMidFields(bf, NextBFItem);
    end
    else
    begin
    right := colright[NextBFItem^.PartCol]+22;
    if currentroom = 4 then
      dec(right, 2)
    else if currentroom in [1,3] then
      dec(right, 3)
    else if currentroom in [10,11] then
    begin
      //if false and (KidBlockY = NextBFItem^.PartRow) then
      //begin

      //end
      //else
        dec(right, 5);
      
    end;
    drawingrect.right := right;
    if EmptyRect(drawingrect) then
      shoulddraw := false;
    end;
  end;

  end;

end;
2,5: begin
  if IsOnTop then
  begin
    if IsSpace(PieceRightId(NextBFItem^.PartCol, NextBFItem^.PartRow)) then
    begin
      NextBFItem^.ItemID := Min(47+(NextBFItem^.PartBack.Back1 and $F), 50);
      NextBFItem^.Left := 51;
      NextBFItem^.Top := 0;
      shoulddraw := true;
    end
    else
      DrawEdge;
  end
  else
  begin
      NextBFItem^.ItemID := 112;
      NextBFItem^.Left := 0;
      NextBFItem^.Top := 0;
    shoulddraw := true;
  end;
  if shoulddraw then
  begin
    if NextBFItem^.Layer = 5 then
    begin
      bf := NextBFItem;
      ResetNextBFItem(5);
      TransferBFItemMidFields(bf, NextBFItem);
    end
    else
    begin
    right := colright[NextBFItem^.PartCol]+22;
    if currentroom = 4 then
      dec(right, 2)
    else if currentroom in [1,3] then
      dec(right, 3)
    else if currentroom in [10,11] then
    begin
      //if false and (KidBlockY = NextBFItem^.PartRow) then
      //begin

      //end
      //else
        dec(right, 5);
      
    end;
    drawingrect.right := right;
    if EmptyRect(drawingrect) then
      shoulddraw := false;
    end;
  end;
  
end;
end;

if shoulddraw then
begin
  if AddNextBFItemToTable then
    ResetNextBFItemWIthPrevInfo(layer);
  drawingrect := oldclip;
  DrawEdge;

end;


end;

procedure DrawWall;
begin
 if NextBFItem^.Layer <> 1 then exit;
 NextBFItem^.Left := 0;
 NextBFItem^.Top := 0;
 NextBFItem^.ItemID := 69 + (NextBFItem^.PartBack.Back1 and $1F);
 if AddNExtBFItemToTable then
   ResetNextBFItemWithPrevInfo(1);
 DrawEdge;
end;

procedure DrawPillar;
var
cliprect: TMacRect;
rect: TMacRect;
shoulddraw: boolean;
bf: PBFImgEntry;
begin
cliprect := drawingrect;
shoulddraw := false;
case NextBFItem^.Layer of
0: begin
  DrawBackWall;
  NextBFItem^.ItemID := 116;
  NextBFItem^.Left := 53;
  NextBFItem^.Top := -50;
  if AddNextBFItemToTable then
    ResetNextBFItemWithPrevInfo(0);
  ComputeOffsetCellRect(rect, pillarrect2, NextBFItem^.PartCol, NextBFItem^.PartRow);
  UnionRect(drawingrect, drawingrect, rect);
  NextBFItem^.Left := $34;
  NextBFItem^.Top := $D;
  NextBFItem^.ItemID := (NextBFItem^.PartBack.Back1 and 7) + 119;
  if NextBFItem^.ItemID > 120 then
    dec(NextBFItem^.ItemID, 4);
  NextBFItem^.Transparent := 0;
  shoulddraw := true;
end;
5: begin
  ComputeOffsetCellRect(rect, pillarrect1, NextBFItem^.PartCol, NextBFItem^.PartRow);
  UnionRect(drawingrect, drawingrect, rect);
  if not DrawPillarInBack(NextBFItem^.PartCol, NextBFItem^.PartRow) then
  begin
    bf := NextBFItem;
    ResetNextBFItem(1);
    TransferBFItemMidFields(bf, NextBFItem);
  end;
  NextBFItem^.Left := $D;
  NextBFItem^.Top := $28;
  NextBFItem^.ItemID := 117 + (NextBFItem^.PartBack.Back1 and 7);
  NextBFItem^.Transparent := 0;
  shoulddraw := true;
end;
1: begin
  NextBFItem^.Left := $E;
  NextBFItem^.Top := -$16;
  NextBFItem^.ItemID := 115;
  shoulddraw := true;
end;
end;
if shoulddraw then
begin
  if not AddNextBFItemToTable then
    NextBFItem^.Transparent := $10;
  drawingrect := cliprect;
end;
end;

procedure DrawShip;
var
  oldrect: TMacRect;
  bf: PBFImgEntry;
begin
  if NextBFItem^.layer = 0 then
  begin
    DrawBackWall;
    exit;
  end;

  if (NextBFItem^.Layer <> 5) or (NextBFItem^.PartCol <> 0) or (NextBFItem^.PartRow<>0) or (NextBFItem^.PartBack.Back1 > 98) then exit;
  oldrect := drawingrect;
  drawingrect := BackBuffer.Rect;
  NextBFItem^.ItemID := 122;
  NextBFItem^.Left := (-NextBFItem^.PartBack.Back1) shl 1;
  NextBFItem^.Top := $BD;
  bf := NextBFItem;
  AddNextBFItemToTable;
  ResetNextBFItem(1);
  TransferBFItemMidFields(bf, NextBFItem);
  NextBFItem^.ItemID := 123;
  NextBFItem^.Left := bf^.Left + 72;
  NextBFItem^.Top := $6A;
  if AddNextBFItemToTable then
    ResetNextBFItemWithPrevInfo(1);
  NextBFItem^.ItemID := 124 + (-bf^.Left) and 3;
  NextBFItem^.Left := bf^.Left;
  NextBFItem^.Top := $D9;
  AddNextBFItemToTable;
  drawingrect := oldrect;
end;

procedure DrawGlass;
var
frame: word;
index: word;
begin
  if NextBFItem^.layer = 0 then
  begin
    DrawBackWall;
    exit;
  end;
  if (NextBFItem^.Layer <> 5)  then exit;
  frame := NextBFItem^.PartBack.Back1 and $F;
  if frame > $E then
    index := 8
  else
    index := glassindexes[frame];
  NextBFItem^.Left := glasstop[index];
  NextBFItem^.Top := glassleft[index];
  NextBFItem^.ItemID := 88 + index;
  AddNextBFItemToTable;


end;

procedure DrawBackWall;
var
prevcontent: word;
backmasked: word;
begin
  backmasked :=  NextBFItem^.PartBack.Back2 and $3F;
  if (backmasked) > 0 then
  begin
    prevcontent := NextBFItem^.PartFore;
    NextBFItem^.PartFore := 0;
    NextBFItem^.Transparent := 0;
    if (currentlevel.leveltype <> 5) or
    (currentroom in [15, 16, 19]) then
      inc(backmasked, 108);

    NextBFItem^.ItemID := 0;
    NextBFItem^.Left := 0;
    NextBFItem^.Top := 0;
    if (currentlevel.LevelType = 5) and not (currentroom in [15, 16, 19]) and (backwall[backmasked] <> 0) then
    begin
      NextBFItem^.ItemID := backwall[backmasked];
      if AddNextBFItemToTable then
        ResetNextBFItemWithPrevInfo(0);
      NextBFItem^.Transparent := $10;
      NextBFItem^.ItemID := 0;
      NextBFItem^.Left := 0;
      NextBFItem^.Top := 0;
    end;
    NextBFItem^.ItemID := backmasked;
    NextBFItem^.Left := 0;
    NextBFItem^.Top := 0;
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(0);
    NextBFItem^.PartFore := prevcontent;
    NextBFItem^.Transparent := $10;
  end;

end;

procedure DrawEdge;
var
maskedback: smallint;
begin
maskedback := ((NextBFItem^.PartBack.Back1 and $F00) shr 8) - 1;
if maskedback < 0 then exit;
if ((NextBFItem^.Layer = 5) and (walledgelayers[maskedback] = 5)) or
((NextBFItem^.Layer = 1) and (walledgelayers[maskedback] = 1)) then
begin
  NextBFItem^.ItemID := walledgepos[maskedback][0];
  NextBFItem^.Left := walledgepos[maskedback][1];
  NextBFItem^.Top := walledgepos[maskedback][2];
  AddNextBFItemToTable;
end
else if (maskedback = 1) and (NextBFItem^.Layer = 1) then
begin
  NextBFItem^.ItemID := walledgepos[0][0];
  NextBFItem^.Left := walledgepos[0][1];
  NextBFItem^.Top := walledgepos[0][2];
  AddNextBFItemToTable;
end;

end;

function IsOnTop: boolean;
begin
  Result := (currentlevel.LevelType = 5) and not (currentroom in [15,16,19]);
end;

function DrawPillarInBack(col: smallint; row: smallint): boolean;
begin
Result := false;
end;

function DrawLedgeInBack(backtype: word; col: smallint; row: smallint): boolean;
begin
  Result := false;
end;

end.
