unit uRuins;

interface

procedure DrawBackWall;
procedure DrawCrevice;
procedure DrawDownPlate;
procedure DrawRuinEmpty;
procedure DrawExit1;
procedure DrawExit2;                                                                    
procedure DrawExitMovable;
procedure DrawFloor;
procedure DrawGate;
procedure DrawGateMovable;
procedure DrawLoose;
procedure DrawPillarBottom;
procedure DrawPillarTop;
procedure DrawPosts;
procedure DrawRubble;
procedure DrawSkeleton;
Procedure DrawUpPlate;                                  
procedure DrawWall;
procedure DrawOverlay;
procedure DrawGateMovableInThroneRoom;
procedure DrawDebris;
procedure EntranceRoomTemplateIn;
procedure EntranceRoomTemplateOut;
procedure ThroneRoomTemplateIn;


implementation

uses uImgTables, uRect, uGlobals, uMacTypes, uPieces, uPop2Types, uCellUtil, uRoomUtil, uColorTables,
uResources, uMacFile;

const
loosemaskodd: array [0..12] of word = (0,1,0,2,2,0,0,0,1,1,1,0,0);
loosemaskeven: array [0..12] of word = (0,2,0,1,1,0,0,2,2,2,0,2,2);
frontoverlay: array[1..12] of array [0..2] of smallint = (
($56, $00, -$05),
($56, -$33, -$05),
($57, $06, $2F),
($58, $14, -$5B),
($59, $01, -$32),
($5A, -$10, -$0D),
($5B, -$2D, -$1E),
($5C, $0E, $00),
($5D, $00, -$08),
($5E, -$22, -$05),
($5F, -$E, $06),
($60, -$13, $0E)
);
midoverlay1: array [13..15] of array [0..2] of smallint = (
($62, $0A, -$3E),
($63, $2D, -$1B),
($64, $20, -$10)
);
midoverlay2: array [1..3] of array [0..2] of smallint = (
($65, $00, -$1F),
($66, $09, -$2A),
($67, $0A, -$33)
);


procedure DrawBackWall;
var
previtem: PBFImgEntry;
rect: TMacRect;
backlayer: word;
backmask: word;
pieceindex: word;
d4: word;
oldfore: word;
begin
backlayer := NextBFItem^.PartBack.Back2 and $1F;
if backlayer = 0 then exit;
if not drawingfull then
begin
  previtem := GetBackTableImgRow(backlayer, NextBFItem^.PartCol-1, NextBFItem^.PartRow);
  if (previtem<>nil) and SectRect(previtem^.ClippedRect, drawingrect, rect) then
  begin
    d4 := 0;
    UnionRect(previtem^.ClippedRect, previtem^.ClippedRect, drawingrect);
    if backlayer in [1..5] then
    begin
      previtem := GetBackTableImgRow(7, NextBFItem^.PartCol - 1, NextBFItem^.PartRow);
      if (previtem <> nil) and SectRect(previtem^.ClippedRect, drawingrect, rect) then
      begin
        UnionRect(previtem^.ClippedRect, previtem^.ClippedRect, drawingrect);
      end;
    end;
  end
  else
  begin
    previtem := nil;
    d4 := 1;
  end;
  end
  else
  begin
    d4 := 0;
    previtem := nil;
  end;
  backmask := (NextBFItem^.PartBack.Back2 and $F00) shr 8;
  if previtem <> nil then exit;
  if (d4 = 0) and (backmask <> 0) and ((NextBFItem^.PartCol <> -1) or (backmask > 3)) and (NextBFItem^.PartRow <> 3) then exit;
  oldfore := NextBFItem^.PartFore;
  NextBFItem^.PartFore := 0;
  NextBFItem^.Transparent := 0;
  if backlayer in [1..5] then
  begin
    if (backlayer = 5) and (backmask in [2,3,6,7]) then
      pieceindex := backmask -2
    else
      pieceindex := backmask;
    inc(pieceindex, $24);
    NextBFItem^.ItemID := 7;
    DrawPiecePos(0, pieceindex);
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(0);
    if (backlayer =5) and (drawingfull) then
    begin
      inc(NextBFItem^.PartCol, 2);
      NextBFItem^.Transparent := 0;
      NextBFItem^.ItemID := 7;
      DrawPiecePos(0, pieceindex);
      if AddNextBFItemToTable then
        ResetNextBFItemWithPrevInfo(0);
      dec(NextBFItem^.PartCol, 2);
      NextBFItem^.Transparent := $10;
    end;
  end;
  if backlayer<>0 then
  begin
    inc(backmask, $24);
    NextBFItem^.ItemID := backlayer;
    DrawPiecePos(0, backmask);
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(0);
  end;
  NextBFItem^.Transparent := $10;
  NextBFItem^.PartFore := oldfore;

end;

procedure DrawCrevice;
var
shown: boolean;
backmask: word;
begin
shown := (NextBFItem^.partBack.back1 and $80) <> 0;
backmask := NextBFItem^.partback.back1 and 3;
case NextBFItem^.layer of
0: begin
  if drawingfull then
    DrawBackWall;
end;
1: begin
  if shown then
  begin
    NextBFItem^.ItemID := 82 + backmask;
    DrawPiecePos;
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(1);
    DrawOverlay;
  end
  else
  begin
    NextBFItem^.partBack.back1 := (NextBFItem^.partBack.back1 and $FFFC) or backmask;
    DrawWall;
  end;

end;
2: begin
  if shown then
  begin
    NextBFItem^.ItemID := backmask + 78;
    DrawPiecePos;
    AddNextBFItemToTable;
  end;

end;
5: begin
  if shown then
  begin
    NextBFItem^.ItemID := backmask + 78;
    DrawPiecePos;
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(5);
  end;
  if backmask = 0 then
    NextBFItem^.PartBack.Back1 := NextBFItem^.PartBack.Back1 or $C
  else
    NextBFItem^.PartBack.Back1 := NextBFItem^.PartBack.Back1 or 8;
  DrawWall;
end;
end;
end;

procedure DrawDownPlate;
var
pieceindex: word;
begin
if (NextBFItem^.PartBack.Back1 and $2000) <> 0 then
  pieceindex := CELL_LOWERED
else
  pieceindex := CELL_RAISED;
case NextBFItem^.layer of
0: DrawBackWall;
1: begin
  NextBFItem^.Transparent := 0;
  NextBFItem^.ItemID := 55;
  DrawPiecePos(-1, pieceindex);
  if not AddNextBFItemToTable then
    NextBFItem^.Transparent := $10;

end;
2,5: begin
  NextBFItem^.ItemID := 53;
  DrawPiecePos(-1, pieceindex);
  AddNextBFItemToTable
end;
end;
end;

procedure DrawRuinEmpty;
var
candraw: boolean;
begin
  If NextBFItem^.Layer = 0 then
  begin
    candraw := false;
    if NextBFItem^.PartRow = drawingrow then
      candraw := true
    else
    begin
      if NextBFItem^.PartRow = (drawingrow + 1) then
        candraw := VisibleAbovePiece(NextBFItem^.PartCol, NextBFItem^.PartRow);
    end;
    if not candraw and (drawingrow = -1) and IsSpace(os_fore) then
    begin
      candraw := true;
    end;
    if candraw then
      DrawBackWall;
    
  end;
  DrawOverlay;
end;

procedure DrawExit1;
begin
case NextBFItem^.layer of
0: begin
  if drawingfull then
  begin
    DrawbackWall;
    NextBFItem^.ItemID := currentpieces[CELL_EXITLEFT].items[0].ItemID;  //escaliers
    NextBFItem^.Left := 52;
    NextBFItem^.Top := currentpieces[CELL_EXITLEFT].items[0].Top;
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(0);
    DrawOverlay;
  end;
  //skippe un peu...
  if (currentroom=currentlevel.InitialRoom) then
  begin
    //NextBFItem^.ItemID := GetPieceValue($156);  //escaliers
    //NextBFItem^.Left := -$2C;
    //NextBFItem^.Top := GetPieceValue($15A);
    //AddNextBFItemToTable;
  end;
end;
1,2,5:
begin
  NextBFItem^.PartBack.Back1 := NextBFItem^.PartBack.Back1 and $FFFC;
  DrawFloor;
end;
end;
end;

procedure DrawExit2;
var
prevback: word;
layer: word;
begin
prevback := NextBFItem^.PartBack.back1;
layer := NextBFItem^.Layer;
case layer of
0:
begin
  if DrawingFull then
    DrawBackWall
  else
  begin
    NextBFItem^.ItemID := currentpieces[CELL_EXITLEFT].items[0].ItemID;  //escaliers
    NextBFItem^.Left := 1;
    NextBFItem^.Top := currentpieces[CELL_EXITLEFT].items[0].Top;
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(0);
  end;
  if (currentroom=currentlevel.InitialRoom) then
  begin
    NextBFItem^.ItemID := currentpieces[CELL_EXITRIGHT].items[0].ItemID;  //escaliers
    NextBFItem^.Left := 7;
    NextBFItem^.Top := currentpieces[CELL_EXITRIGHT].items[0].Top;
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(0);
  end;


  if NextBFItem = nil then
    ResetNextBFItemWithPrevInfo(0);
  NextBFItem^.PartBack.back1 := prevback;
  DrawExitMovable;
end;
1,2,5: begin
  NextBFItem^.PartBack.back1 := (prevback and $FFFC) or 2;
  DrawFloor;
  if Layer = 5 then
  begin
    if NextBFItem  = nil then
      ResetNextBFItemWithPrevInfo(5);
    NextBFItem^.PartBack.back1 := prevback;
    NextBFItem^.ItemID := GetPieceValue($47C);
    NextBFItem^.Left := GetPieceValue($47E);
    NextBFItem^.Top := GetPieceValue($480);
    AddNextBFItemToTable;

  end;

end;
end;
end;

procedure DrawExitMovable;
var
backmasked: word;
oldrect: TMacRect;
oldgamerect: TMacRect;
prevbf: PBFImgEntry;
begin
  if NextBFItem^.Layer <> 0 then exit;
  oldrect := drawingrect;
  oldgamerect := backbuffer.rect;
  oldgamerect.top := NextBFItem^.partrow * 120 - 10;
  if SectRect(oldgamerect, drawingrect, drawingrect) then
  begin
    backmasked := NextBFItem^.PartBack.back1 and $FF;
    if backmasked > $4F then
      backmasked := $4F;
    NextBFItem^.ItemID := GetPieceValue($476);
    NextBFItem^.Left := GetPieceValue($478);
    NextBFItem^.Top := -$22 - (backmasked + 1);
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(0);
    if Kid.Posn in [217..226] then
    begin
      prevbf := NextBFItem;
      ResetNextBFItem(1);
      TransferBFItemMidFields(prevbf, NextBFItem);
    end;
    NextBFItem^.ItemID := GetPieceValue($47C);
    NextBFItem^.Left := GetPieceValue($47E);
    NextBFItem^.Top := GetPieceValue($480);
    AddNextBFItemToTable;
  end;
  drawingrect := oldrect;
  
end;

procedure DrawFloor;
var
layer: word;
begin
  case NextBFItem^.Layer of
  0: DrawBackWall;
  1: begin
    NextBFItem^.ItemID := 18;
    DrawPiecePos(-1, CELL_FLOOR);
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(1);
    DrawOverlay;
  end;
  2,5: begin
    layer := NextBFItem^.Layer;
    NextBFItem^.ItemID := 14 + (NextBFItem^.PartBack.Back1 and 3);
    DrawPiecePos(-1, CELL_FLOOR);
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(layer);
    DrawOverlay;
  end;
  end;
end;

procedure DrawGate;
var
candraw: boolean;
layer: word;
begin
  candraw := false;
  layer := NextBFItem^.Layer;
  case layer of
  0: DrawBackWall;
  1: begin
    DrawFloor;
    if NextBFItem = nil then
      ResetNextBFItemWithPrevInfo(1);
    DrawPiece;
    candraw := true;
  end;
  2,5: begin
    DrawPiece;
    candraw := true;
  end;
  end;
  if candraw then
  begin
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(layer);
    DrawGateMovable;
    if NextBFItem=nil then
      ResetNextBFItemWithPrevInfo(layer);
    DrawOverlay;
  end;
end;

procedure DrawGateMovable;
var
oldrect: TMacRect;
oldgamerect: TMacRect;
backmasked: word;
layer: word;
begin
  if not (NextBFItem^.Layer in [2,5]) then exit;
  oldrect := drawingrect;
  oldgamerect := backbuffer.Rect;
  oldgamerect.top := NextBFItem^.PartRow * 120 - 19;
  if sectrect(oldgamerect, drawingrect, drawingrect) then
  begin
    if (currentroom = 9) and (currentlevel.LevelNumber = 8) then
    begin
      if NextBFItem^.Layer = 2 then
        DrawGateMovableInThroneRoom;
    end
    else
    begin
      NextBFItem^.ItemID := GetPieceValue($454);
      NextBFItem^.Left := GetPieceValue($456);
      backmasked := NextBFItem^.PartBack.Back1 and $FF;
      backmasked := backmasked shr 1;
      if backmasked > $5C then backmasked := $5C;
      NextBFItem^.Top := -10 - backmasked;
      layer := NextBFItem^.Layer;
      if AddNextBFItemToTable then
        ResetNextBFItemWithPrevInfo(layer);
    end;
  end;
  drawingrect := oldrect;
end;

procedure DrawLoose;
var
candraw: boolean;
backmasked: word;
layer: word;
begin
  candraw := false;
  backmasked := NextBFItem^.PartBack.Back1 and $F;
  if backmasked <> 13 then
  begin
    if (NextBFItem^.PartCol and 1) = 1 then
      backmasked := loosemaskodd[backmasked]
    else
      backmasked := loosemaskeven[backmasked];
  end;
  case NextBFItem^.Layer of
  0: DrawBackWall;
  1: begin
    if backmasked <> 13 then
    begin
      if backmasked <> 0 then
      begin
        NextBFItem^.ItemID := 49 + backmasked;
        DrawPiecePos;
        if AddNextBFItemToTable then
          ResetNextBFItemWithPrevInfo(1);
        DrawOverlay;
      end
      else
        candraw := true;
    end
    else
      DrawOverlay;
  end;
  2,5: begin
    if backmasked <> 13 then
    begin
      if backmasked <> 0 then
      begin
        layer := NextBFItem^.layer;
        NextBFItem^.ItemID := 47 + backmasked;
        DrawPiecePos;
        if AddNextBFItemToTable then
          ResetNextBFItemWithPrevInfo(layer);
        DrawOverlay;
      end
      else
        candraw := true;
    end
    else
      DrawOverlay;

  end;
  end;
  if candraw then
  begin
    NextBFItem^.PartBack.Back1 := NextBFItem^.PartBack.Back1 and $FFFC;
    DrawFloor;
  end;
  

end;

procedure DrawPillarBottom;
var
candraw: boolean;
layer: word;
begin
candraw := false;
case NextBFItem^.Layer of
0: DrawBackWall;
1: begin
  DrawFloor;
  if NextBFItem = nil then
    ResetNextBFItemWithPrevInfo(1);
  DrawPiece;
  candraw := true;
end;
2,5: begin
  DrawPiece;
  candraw := true;
end;
end;

if candraw then
begin
  layer := NextBFItem^.layer;
  if AddNextBFItemToTable then
    ResetNextBFItemWithPrevInfo(layer);
  DrawOverlay;
end;

end;

procedure DrawPillarTop;
var
candraw: boolean;
layer: word;
begin
  candraw := false;
case NextBFItem^.Layer of
0: begin
  DrawBackWall;
  DrawPiece;
  candraw := true;
end;
1: begin
  DrawPiece;
  candraw := true;
end;
end;
if candraw then
begin
  layer := NextBFItem^.layer;
  if AddNextBFItemToTable then
    ResetNextBFItemWithPrevInfo(layer);
  DrawOverlay;
end;
end;

procedure DrawPosts;
var
layer: word;
oldback: word;
begin
oldback := NextBFItem^.PartBack.Back1;
layer := NextBFItem^.Layer;
case layer of
0: DrawBackWall;
1: begin
  NextBFItem^.PartBack.Back1 := oldback and $F00;
  DrawFloor;
  if NextBFItem = nil then
    ResetNextBFItemWithPrevInfo(1);
  NextBFItem^.PartBack.Back1 := oldback;
  NextBFItem^.ItemID := (oldback and 3) + 38;
  DrawPiecePos;
 if AddNextBFItemToTable then
   ResetNextBFItemWithPrevInfo(1);
 DrawOverlay;
end;
2,5: begin
  DrawFloor;
  if NextBFItem = nil then
    ResetNextBFItemWithPrevInfo(layer);
  NextBFItem^.ItemID := (oldback and 3) + 35;
  DrawPiecePos;
  AddNextBFItemToTable;
end;
end;
end;

procedure DrawRubble;
var
backmasked: word;
oldback: word;
layer: word;
begin
layer := NextBFItem^.Layer;
oldback := NextBFItem^.PartBack.Back1;
backmasked := NextBFItem^.PartBack.Back1 and $FFBF;
if (NextBFItem^.PartBack.Back1 and $40) <> 0 then
begin
    NextBFItem^.PartBack.back1 := backmasked;
  if (backmasked and 4) <> 0 then
    DrawUpPlate
  else if (backmasked and 8) <> 0 then
    DrawDownPlate
  else
    DrawFloor;
end
else if layer = 0 then
  DrawBackWall
else
begin
  if layer = 1 then
  begin
    NextBFItem^.PartBack.back1 := backmasked;
    DrawFloor;
  end;
end;

if NextBFItem = nil then
  ResetNextBFItemWithPrevInfo(layer);
NextBFItem^.PartBack.Back1 := oldback and $BFFF;
DrawDebris;
if NextBFItem = nil then
  ResetNextBFItemWithPrevInfo(layer);
DrawOverlay;
end;

procedure DrawSkeleton;
var
candraw: boolean;
layer: word;
begin
  candraw := false;
  layer := NextBFItem^.layer;
  case layer of
  0: DrawBackWall;
  1: begin
    DrawFloor;
    if NextBFItem = nil then
      ResetNextBFItemWithPrevInfo(1);
    DrawPiece;
    candraw := true;
  end;
  2,5: begin
    DrawPiece;
    candraw := true;
  end;  
  end;
  if candraw then
  begin
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(layer);
    DrawOverlay;
  end;

end;

Procedure DrawUpPlate;
var
pieceindex: word;
begin
  if (NextBFItem^.PartBack.Back1 and $2000) <> 0 then
    pieceindex := 6
  else
    pieceindex := 5;
  case NextBFItem^.Layer of
  0: DrawBackWall;
  1: begin
    NextBFItem^.Transparent := 0;
    NextBFItem^.ItemID := 54;
    DrawPiecePos(-1, pieceindex);
    if not AddNextBFItemToTable then
      NextBFItem^.Transparent := $10;
  end;
  2,5: begin
    NextBFItem^.ItemID := 52;
    DrawPiecePos(-1, pieceindex);
    AddNextBFItemToTable;
  end;
  end;
end;

procedure DrawWall;
var
atright: word;
backmasked: word;
begin
  case NextBFItem^.layer of
  0: if drawingfull then DrawBackWall;
  1: begin
    NextBFItem^.ItemID := 27 + (NextBFItem^.PartBack.Back1 and 3);
    DrawPiecePos(-1, CELL_WALL);
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(1);
    DrawOverlay;

  end;
  5: begin
    backmasked := (NextBFItem^.PartBack.back1 and $C) shr 2;
    if backmasked = 2 then exit;
    if currentroom <> 0 then
      atright := PieceRightId(NextBFItem^.PartCol, NextBFItem^.PartRow);
    if (currentroom = 0) or (AtRight<>CELL_WALL) then
    begin
      if backmasked <> 3 then
        inc(backmasked, 25)
      else if (NextBFItem^.PartBack.Back1 and $80) <> 0 then
        backmasked := 77
      else
        backmasked := 76;
      NextBFItem^.ItemID := backmasked;
      DrawPiecePos(0, CELL_WALL);
      AddNextBFItemToTable;
    end;
  end;
  end;
end;

procedure DrawOverlay;
var
backmasked: word;
begin
  if NextBFItem^.Layer = 1 then
  begin
    backmasked := NextBFItem^.Partback.back1 and $F00;
    if backmasked = 0 then exit;
    if backmasked >= $D00 then exit;
    backmasked := backmasked shr 8;
    if (backmasked <> 2) or (not drawingfull) then
    begin
      NextBFItem^.ItemID := frontoverlay[backmasked][0];
      NextBFItem^.Left := frontoverlay[backmasked][1];
      NextBFItem^.Top := frontoverlay[backmasked][2];
      AddNextBFItemToTable;
    end;
  end
  else if NextBFItem^.Layer = 5 then
  begin
    backmasked := NextBFItem^.PartBack.back1 and $F00;
    backmasked := backmasked shr 8;
    if backmasked in [13..15] then
    begin
      if backmasked = 15 then
        NextBFItem^.PartFore := CELL_FLOOR
      else
        NextBFITem^.PartFore := CELL_EMPTY;
      NextBFItem^.ItemID := midoverlay1[backmasked][0];
      NextBFItem^.Left := midoverlay1[backmasked][1];
      NextBFItem^.Top := midoverlay1[backmasked][2];
      AddNextBFItemToTable;
    end
    else
    begin
      backmasked := (NextBFItem^.PartBack.back1 and $3000) shr 12;
      if backmasked = 0 then exit;
      NextBFItem^.ItemID := midoverlay2[backmasked][0];
      NextBFItem^.Left := midoverlay2[backmasked][1];
      NextBFItem^.Top := midoverlay2[backmasked][2];
      AddNextBFItemToTable;
    end;
  end;

end;

procedure DrawGateMovableInThroneRoom;
begin
  custompieces^.Content[6].Layer := 1;
  DrawCustomRoomIMg(6,1);
  custompieces^.Content[6].layer := 0;
end;

procedure DrawDebris;
var
candraw: boolean;
backmasked: word;
layer: word;
begin
  candraw := false;
  backmasked := (NextBFItem^.partback.back1 and $30) shr 4;
  case NextBFItem^.Layer of
  1: begin
    if backmasked = 0 then
    begin
      NextBFItem^.ItemID := 22;
      DrawPiecePos(-1, CELL_DEBRIS);
      candraw := true;
    end;
  end;
  2,5: begin
    NextBFItem^.ItemID := backmasked + 19;
    DrawPiecePos(-1, CELL_DEBRIS);
    candraw := true;
  end;
  end;
  if candraw then
  begin
    layer := NextBFItem^.layer;
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(layer);
    DrawOverlay;
  end;
end;

procedure EntranceRoomTemplateIn;
begin
  PopSetPalette(3502, $40);
end;

procedure ThroneRoomTemplateIn;
begin
  PopSetPalette(3501, $30);
end;


procedure EntranceRoomTemplateOut;
var
curfile: PResFile;
begin
  curfile := PopCurResFile;
  PopUseResFile(levelresources[currentlevel.leveltype]);
  PopSetPalette(3500, $40);
  PopUseResFile(resPrince);
  PopSetPalette(3000, $E0);
  POpUseResFile(curfile);
end;

end.


