unit uShapeList;

interface

uses uMacFile, uPop2Types, uMacTypes;

function GetSHPLResource(id: integer): PResource;
function hGetNMapShpList(id: smallint; window: boolean): pointer;
function LoadShapeList(id: smallint; window: boolean): pointer;
function PrinceGetnShapeItem(shapeset: PShapeList; item: integer): pointer;
function PrinceGetnShapeItemSize(shapeset: PShapeList; item: integer; var size: TMacPoint): boolean;
procedure UnloadShapeList(list: PShapeList);

implementation

uses uResources, uColorTables, uSwapper, uShapes;

function GetSHPLResource(id: integer): PResource;
begin
  Result := PoPGetResource('SHPL', id);
end;

function hGetNMapShpList(id: smallint; window: boolean): pointer;
var
data: pointer;
res: PResource;
begin
res := GetSHPLResource(id);
GetMem(data, res^.size);
move(res^.data^, data^, res^.size);
if window then
  SetCTBLColor(id, -1);
Result := data;
end;

function LoadShapeList(id: smallint; window: boolean): pointer;
var
data: pointer;
shapelist: PShapeList;
nbitems: smallint;
  ctr: Integer;
shape: pointer;
begin
data := hGetNMapShpList(id, window);
nbitems := swap2(pword(integer(data) + 2)^);

shapelist:= allocmem(8+nbitems*sizeof(TShapeListEntry));
shapelist.ListID := swap2(pword(data)^);
shapelist.Data := data;
shapelist.NbItems := nbitems;
for ctr := 1 to nbitems do
begin
  shape := GetShape(shapelist.ListID + ctr - 1 );
  if shape <> nil then
  begin
    if pword(integer(shape) + 6)^ <> 0 then
    begin
      shapelist.Content[ctr -1].shape := shape;
    end
    else
      FreeMem(shape);
  end;
end;

Result := shapelist;

end;

function PrinceGetnShapeItem(shapeset: PShapeList; item: integer): pointer;
begin
  if item > shapeset^.NbItems then
    Result := nil
  else
    Result := shapeset^.Content[item - 1].shape;
end;

function PrinceGetnShapeItemSize(shapeset: PShapeList; item: integer; var size: TMacPoint): boolean;
var
shape: pointer;
begin
shape := PrinceGetnShapeItem(shapeset, item);
if shape <> nil then
begin
size.y := swap2(pword(integer(shape) + 6)^);
size.x := swap2(pword(integer(shape) + 4)^);
end
else
begin
  size.x := 0;
  size.y := 0;
end;
Result := (size.x > 0) and (size.y > 0)
end;

procedure UnloadShapeList(list: PShapeList);
var
  ctr: Integer;
begin
  for ctr := 0 to list^.NbItems - 1 do
    if list^.Content[ctr].shape <> nil then
      FreeMem(list^.Content[ctr].shape);
  FreeMem(list^.Data);
  FreeMem(list);
end;


end.
