unit uShapes;

interface

function UnpackShapeLZ(var data:pointer; var srcsize:cardinal):boolean;
function GetShape(id: word): pointer;
procedure FlipSHAPLR(data: pbyte);
procedure FlipSHAPTB(data: pbyte);
procedure FlipSHAP(data: pbyte; fliptype: byte);


implementation

uses uCompression, uResources, uMacFile, uSwapper, uGlobals;
const
byteflipper: array [0..255] of byte =
(
$00, $80, $40, $C0, $20, $A0, $60, $E0, $10, $90, $50, $D0, $30, $B0, $70, $F0,
$08, $88, $48, $C8, $28, $A8, $68, $E8, $18, $98, $58, $D8, $38, $B8, $78, $F8,
$04, $84, $44, $C4, $24, $A4, $64, $E4, $14, $94, $54, $D4, $34, $B4, $74, $F4,
$0C, $8C, $4C, $CC, $2C, $AC, $6C, $EC, $1C, $9C, $5C, $DC, $3C, $BC, $7C, $FC,
$02, $82, $42, $C2, $22, $A2, $62, $E2, $12, $92, $52, $D2, $32, $B2, $72, $F2,
$0A, $8A, $4A, $CA, $2A, $AA, $6A, $EA, $1A, $9A, $5A, $DA, $3A, $BA, $7A, $FA,
$06, $86, $46, $C6, $26, $A6, $66, $E6, $16, $96, $56, $D6, $36, $B6, $76, $F6,
$0E, $8E, $4E, $CE, $2E, $AE, $6E, $EE, $1E, $9E, $5E, $DE, $3E, $BE, $7E, $FE,
$01, $81, $41, $C1, $21, $A1, $61, $E1, $11, $91, $51, $D1, $31, $B1, $71, $F1,
$09, $89, $49, $C9, $29, $A9, $69, $E9, $19, $99, $59, $D9, $39, $B9, $79, $F9,
$05, $85, $45, $C5, $25, $A5, $65, $E5, $15, $95, $55, $D5, $35, $B5, $75, $F5,
$0D, $8D, $4D, $CD, $2D, $AD, $6D, $ED, $1D, $9D, $5D, $DD, $3D, $BD, $7D, $FD,
$03, $83, $43, $C3, $23, $A3, $63, $E3, $13, $93, $53, $D3, $33, $B3, $73, $F3,
$0B, $8B, $4B, $CB, $2B, $AB, $6B, $EB, $1B, $9B, $5B, $DB, $3B, $BB, $7B, $FB,
$07, $87, $47, $C7, $27, $A7, $67, $E7, $17, $97, $57, $D7, $37, $B7, $77, $F7,
$0F, $8F, $4F, $CF, $2F, $AF, $6F, $EF, $1F, $9F, $5F, $DF, $3F, $BF, $7F, $FF

);

function UnpackShapeLZ(var data:pointer; var srcsize:cardinal):boolean;
begin
  Result := UnpackLZ(data, srcsize);
end;

function GetShape(id: word): pointer;
var
res: PResource;
resdata: pointer;
ressize: cardinal;
bufsize: integer;
dest: pbyte;
maxsrc: pbyte;
maxdest: pbyte;
bvar: byte;
bval: byte;
initial: pointer;
curfile: PResFile;
begin
  Result := nil;
  res := PoPGetResource('SHAP', id);
  if res = nil then
  begin
    curfile := PopCurResFile;
    PopUseResFile(resKid);
    res := PoPGetResource('SHAP', id);
    if res = nil then
    begin
      PopUseResFile(resPrince);
      res := PoPGetResource('SHAP', id);
    end;
    PopUseResFile(curfile);
  end;
  if res = nil then exit;
  //on se dtache de la ressource pour pas la changer
  ressize := res^.size;
  getmem(resdata, ressize);
  move(res^.data^, resdata^, ressize);
  if (pbyte(resdata)^ and 4) <> 0 then
    UnpackShapeLZ(resdata, ressize);
  if (pbyte(resdata)^ and 2) <> 0 then
  begin
    initial := resdata;
    bufsize := swap2(pword(integer(resdata) + 2)^) * swap2(pword(integer(resdata) + 6)^);
    if (pbyte(resdata)^ and 1) <> 0 then
      bufsize := bufsize + bufsize;
    bufsize := bufsize + 12;
    getmem(dest, bufsize);
    Result := dest;

    maxsrc := pbyte(integer(resdata) + ressize);
    maxdest := pbyte(integer(dest) + bufsize);

    move(resdata^, dest^, 12);
    inc(pbyte(resdata), 12);
    inc(dest, 12);
    while (cardinal(resdata) < cardinal(maxsrc)) and (cardinal(dest) < cardinal(maxdest)) do
    begin
      bvar := pbyte(resdata)^;
      inc(pbyte(resdata));
      if (bvar and $80) <> 0  then
      begin
        bval := pbyte(resdata)^;
        inc(pbyte(resdata));
        bvar := (bvar and $7F) + 3;
        FillChar(dest^, bvar, bval);
        inc(dest, bvar);
      end
      else
      begin
        move(resdata^, dest^, bvar);
        inc(pbyte(resdata), bvar);
        inc(dest, bvar);
      end;
    end;

    pword(Result)^ := pword(Result)^ and $F1;

    FreeMem(initial);
  end
  else
    Result := resdata;

end;


procedure FlipSHAPLR(data: pbyte);
var
pitch: word;
height: word;
width: word;
rowstart: pbyte;
iter1: pbyte;
iter2: pbyte;
  ctr: word;
b1: byte;
limit: word;
off: byte;
extra: word;
begin
if data^ = $B0 then
begin
  rowstart := data;
  width := swap2(pword(integer(data) + 4)^);
  height := swap2(pword(integer(data) + 6)^);
  pitch := swap2(pword(integer(data) + 2)^);

  inc(rowstart,$C);

  for ctr := 1 to height do
  begin
    iter1 := rowstart;
    iter2 := rowstart;
    inc(iter2, width - 1);

    while integer(iter1) < integer(iter2) do
    begin
      b1 := iter1^;
      iter1^ := iter2^;
      iter2^ := b1;
      inc(iter1);
      dec(iter2);
    end;
    inc(rowstart, pitch);
  end;
end
else if data^ = $90 then
begin
  rowstart := data;
  width := swap2(pword(integer(data) + 4)^);
  height := swap2(pword(integer(data) + 6)^);
  pitch := swap2(pword(integer(data) + 2)^);
  off := swap2(pword(data)^) and $F;

  limit := (width + off) div 8;
  extra := 8-((width + off) mod 8);
  if extra < 8 then
    inc(limit)
  else
    dec(extra, 8);

  pbyte(integer(data)+1)^ := (pbyte(integer(data)+1)^ and $F0) or extra;

  inc(rowstart,$C);

  for ctr := 1 to height do
  begin
    iter1 := rowstart;
    iter2 := rowstart;
    inc(iter2, limit - 1);

    while integer(iter1) < integer(iter2) do
    begin
      b1 := byteflipper[iter1^];
      iter1^ := byteflipper[iter2^];
      iter2^ := b1;
      inc(iter1);
      dec(iter2);
    end;
    if integer(iter1) = integer(iter2) then
      iter1^ := byteflipper[iter1^];
    inc(rowstart, pitch);
  end;


end;
inc(data);
data^ := data^ xor $10;
end;

procedure FlipSHAPTB(data: pbyte);
var
pitch: word;
height: word;
width: word;
rowstart1: pbyte;
rowstart2: pbyte;
iter1: pbyte;
iter2: pbyte;
  ctr: word;
b1: byte;
begin
if data^ = $B0 then
begin
  rowstart1 := data;
  width := swap2(pword(integer(data) + 4)^);
  height := swap2(pword(integer(data) + 6)^);
  pitch := swap2(pword(integer(data) + 2)^);

  inc(rowstart1,$C);
  rowstart2 := rowstart1;
  inc(rowstart2, (height - 1)*pitch);

  while integer(rowstart1) < integer(rowstart2) do
  begin
    iter1 := rowstart1;
    iter2 := rowstart2;

    for ctr := 1 to width do
    begin
      b1 := iter1^;
      iter1^ := iter2^;
      iter2^ := b1;
      inc(iter1);
      inc(iter2);
    end;
    inc(rowstart1, pitch);
    dec(rowstart2, pitch);
  end;
end
else if data^ = $90 then
begin
  rowstart1 := data;
  height := swap2(pword(integer(data) + 6)^);
  pitch := swap2(pword(integer(data) + 2)^);

  inc(rowstart1,$C);
  rowstart2 := rowstart1;
  inc(rowstart2, (height - 1)*pitch);

  while integer(rowstart1) < integer(rowstart2) do
  begin
    iter1 := rowstart1;
    iter2 := rowstart2;

    for ctr := 1 to pitch do
    begin
      b1 := iter1^;
      iter1^ := iter2^;
      iter2^ := b1;
      inc(iter1);
      inc(iter2);
    end;
    inc(rowstart1, pitch);
    dec(rowstart2, pitch);
  end;
end;
inc(data);
data^ := data^ xor $20;
end;

procedure FlipSHAP(data: pbyte; fliptype: byte);
var
current: byte;
begin
current := pbyte(integer(data) + 1)^ and $30;
current := current xor (fliptype shl 4);
if (current and $20) <> 0 then
  FlipSHAPTB(data);
if (current and $10) <> 0 then
  FlipSHAPLR(data);
end;

end.
