unit uShared;

interface

procedure DrawPotion;
function GetFlaskBubbleColor(back: word): word;
procedure DrawScythe1;
procedure DrawScythe2;
procedure DrawScytheDebris;
procedure DrawSword;
implementation

uses uImgTables, uLevelDraw, uGlobals, uPop2Types, uPieces, uRuins, uTemple;

const
ScytheIndexes: array[0..31] of smallint =
(
$00,$3D,$3A,$3B,$3A,$3A,$3A,$3B,
$3A,$3A,$3A,$3A,$3A,$3A,$3A,$3A,
$3C,$3D,$3E,$00,$3A,$2F,-$3B,$3B,
$36,-$3B,$3C,$4E,-$3B,$3D,$23,-$33);

ScytheInfos:array [0..1] of array[$3A..$3E] of array[0..2] of smallint = (
(($3A, $2F, -$3B),
($3B, $36, -$3B),
($3C, $4E, -$3B),
($3D, $23, -$33),
($3E, $40, -$41)),

(($3F, $19, -$29),
($40, $23, -$28),
($41, $59, -$28),
($42, $42, -$33),
(0,0,0))
);

procedure DrawPotion;
var
layer: word;
mask1: word;
offset: word;
prevback: word;
color: word;
begin

layer := NextBFItem^.layer;
prevback := NextBFItem^.PartBack.Back1;
if (currentlevel.leveltype in [2,3,4,5]) and (custompieces = nil) then
begin
NextBFItem^.PartBack.Back1 := NextBFItem^.PartBack.Back1 and $FF00;
DrawItem(cell_floor);
if NextBFItem = nil then
  ResetNextBFItemWIthPrevInfo(layer);
end;
NextBFItem^.partback.back1 := prevback;

if layer <> 1 then exit;

mask1 := prevback and $E0;
if (mask1 >= $40) and (mask1 < $A0) then
offset := 1
else
offset := 0;
NextBFItem^.ImgSet := 1;
DrawPiecePos;
NextBFItem^.ItemID := offset+1;
if AddNextBFItemToTable then
begin
  ResetNextBFItemWithPrevInfo(layer);
  NextBFItem^.ImgSet := 1;
end;
if mask1 <> 0 then
begin
  mask1 := prevback and $1F;
  if (mask1 <> $1C) and ((mask1 < $A) or (mask1 > $D)) and ((mask1 - 14) < $A) then
  begin
    color := GetFlaskBubbleColor(prevback);
    if mask1 > $D then
    begin
      dec(mask1, $E);
      prevback := 1;
    end
    else
    begin
      prevback := 0;
    end;
    NextBFItem^.Transparent := color;
    NextBFItem^.Flip := prevback;
    NextBFItem^.ItemID := mask1+3;
    NextBFItem^.Left := currentpieces[60].Items[2].Left;
    if offset = 1 then
      NextBFItem^.Top := -$25
    else
      NextBFItem^.Top := -$21;
    if AddNextBFItemToTable then
    begin
      ResetNextBFItemWithPrevInfo(1);
      NextBFItem^.ImgSet := 1;
    end;
    NextBFItem^.Transparent := color;
    NextBFItem^.Flip := prevback;
    NextBFItem^.ItemID := mask1+3;
    NextBFItem^.Left := currentpieces[60].Items[2].Left;
    if offset = 1 then
      NextBFItem^.Top := -$25
    else
      NextBFItem^.Top := -$21;
    if AddNextBFItemToTable then
    begin
      ResetNextBFItemWIthPRevInfo(1);
      NextBFItem^.ImgSet := 1;
    end;
    NextBFItem^.Transparent := color + 1;
    NextBFItem.Flip := prevback;
    NextBFItem^.ItemID := mask1+13;
    NextBFItem^.Left := currentpieces[60].Items[2].Left;
    if offset = 1 then
      NextBFItem^.Top := -$25
    else
      NextBFItem^.Top := -$21;
  AddNextBFItemToTable;

  end;
  if NextBFItem <> nil then
  NextBFItem^.ImgSet := 4;

end;



end;

function GetFlaskBubbleColor(back: word): word;
begin
case back and $E0 of
$20, $40: Result := $E9;
$A0: Result := $ED;
else Result := $EB;
end;
end;

procedure DrawScythe1;
var
idx: smallint;
layer: word;
oldback: word;
backmasked: word;
candraw: boolean;
begin
  layer := NextBFItem^.layer;
  oldback := NextBFItem^.PartBack.Back1;
  NextBFItem^.PartBack.Back1 := oldback and $FF00;
  if currentlevel.leveltype = 4 then
    uRuins.DrawFloor
  else
  begin
    uTemple.DrawFloor
  end;
  if NextBFItem = nil then
    ResetNextBFItemWithPrevInfo(layer);
  NextBFItem^.Transparent := $10;
  NextBFItem^.PartBack.Back1 := oldback;
  backmasked := oldback and $40;
  candraw := false;
  case layer of
  0: begin
    if (oldback and $80)<>0 then
    begin
      NextBFItem^.ItemID := 57;
      NextBFItem^.Top := -66;
    end
    else
    begin
      NextBFItem^.ItemID := 56;
      NextBFItem^.Top := -69;
    end;
    NextBFItem^.Left := GetPieceValue($F4);
    candraw := true;
  end;
  1: begin
  idx := scytheindexes[oldback and $1F];
  if idx in [58..60] then
  begin
    NextBFItem^.ItemID := ScytheInfos[0][idx][0];
    NextBFItem^.Left := ScytheInfos[0][idx][1];
    NextBFItem^.Top := ScytheInfos[0][idx][2];
    if backmasked <> 0 then
      inc(NextBFItem^.ItemID, 9);
    candraw := true;
  end;
  end;
  5: begin
  idx := scytheindexes[oldback and $1F];
  if idx in [58..60] then
  begin
    NextBFItem^.ItemID := ScytheInfos[1][idx][0];
    NextBFItem^.Left := ScytheInfos[1][idx][1];
    NextBFItem^.Top := ScytheInfos[1][idx][2];
    if backmasked <> 0 then
      inc(NextBFItem^.ItemID, 9);
    candraw := true;
  end;
  end;
  end;
  if candraw then
  begin
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(layer);
  end;
  DrawScytheDebris;
end;

procedure DrawScythe2;
var
idx: smallint;
layer: word;
oldback: word;
backmasked: word;
candraw: boolean;
begin
  layer := NextBFItem^.layer;
  oldback := NextBFItem^.PartBack.Back1;
  NextBFItem^.PartBack.Back1 := oldback and $FF00;
  if currentlevel.leveltype = 4 then
    inc(NextBFItem^.PartBack.Back1);
  if currentlevel.leveltype = 4 then
    uRuins.DrawFloor
  else
  begin
    uTemple.DrawFloor
  end;
  if NextBFItem = nil then
    ResetNextBFItemWithPrevInfo(layer);
  NextBFItem^.Transparent := $10;
  NextBFItem^.PartBack.Back1 := oldback;
  backmasked := oldback and $40;
  candraw := false;
  case layer of
  0: begin
    if not drawingfull and (drawingcol-1 = NextBFItem^.partCol) then
    begin
    if (oldback and $80)<>0 then
    begin
      NextBFItem^.ItemID := 57;
      NextBFItem^.Top := -66;
    end
    else
    begin
      NextBFItem^.ItemID := 56;
      NextBFItem^.Top := -69;
    end;
    NextBFItem^.Left := GetPieceValue($108);
    candraw := true;
    end;
  end;
  1: begin
  idx := scytheindexes[oldback and $1F];
  if ((idx in [61,62]) or (idx<>0)) and (idx<>$3E) then
  begin
    NextBFItem^.ItemID := ScytheInfos[0][idx][0];
    NextBFItem^.Left := ScytheInfos[0][idx][1];
    NextBFItem^.Top := ScytheInfos[0][idx][2];
    if idx <> 61 then
      dec(NextBFItem^.Left, 51);
    if backmasked <> 0 then
      inc(NextBFItem^.ItemID, 9);
    candraw := true;
  end;
  end;
  5: begin
  idx := scytheindexes[oldback and $1F];
  if idx in [61,62] then
  begin
    NextBFItem^.ItemID := ScytheInfos[1][idx][0];
    NextBFItem^.Left := ScytheInfos[1][idx][1];
    NextBFItem^.Top := ScytheInfos[1][idx][2];
    if backmasked <> 0 then
      inc(NextBFItem^.ItemID, 9);
    candraw := true;
  end;
  end;
  end;
  if candraw then
  begin
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(layer);
  end;
  DrawScytheDebris;
end;

procedure DrawScytheDebris;
begin
  if (NextBFItem^.PartBack.Back1 and $20) = 0 then exit;
  if currentlevel.LevelType = 4 then
    uRuins.DrawDebris
  else
  begin
    uTemple.DrawDebris;
  end;
end;

procedure DrawSword;
var
layer: word;
oldback: word;
oldset: word;
backmasked: word;
begin
  layer := NextBFItem^.Layer;
  oldback := NextBFItem^.partback.back1;
  oldset := NextBFItem^.ImgSet;
  if isassigned(1) then
  begin
    if (currentroom<>9) or (drawingrow=-1) or (currentlevel.levelnumber<>8) then
    begin
      NextBFItem^.partback.back1 := oldback and $FFFC;
      DrawItem(1);
      if NextBFItem = nil then
        ResetNextBFItemWithPrevInfo(layer);
      NextBFItem^.partback.back1 := oldback;
    end;
  end;
  if layer = 1 then
  begin
    DrawPiece;
    backmasked := oldback and 3;
    if (backmasked = SwordType) or ((SwordType = -1) and (backmasked = 1)) then
      NextBFItem^.ItemID := 11
    else
      NextBFItem^.ItemID := 46;
    NextBFItem^.ImgSet := 0;
    AddNextBFItemToTable;
    if NextBFItem <> nil then
      NextBFItem^.ImgSet := oldset;

    
  end;

end;

end.
