unit uTemple;

interface

procedure DrawBackWall;
procedure DrawEmpty;
procedure DrawFloor;
procedure DrawEdge;
procedure DrawSpikes;
procedure DrawPosts;
procedure DrawGate;
procedure DrawGateMovable;
procedure DrawUpPlate;
procedure DrawDownPlate;
procedure DrawPillarBottom;
procedure DrawPillarTop;
procedure DrawLoose;
procedure DrawRubble;
procedure DrawDebris;
procedure DrawExit1;
procedure DrawExit2;
procedure DrawExitMovable;
procedure DrawTorch;
procedure DrawWall;
procedure DrawFlip;
procedure DrawTorchDebris;
procedure DrawFlame;
procedure AltarRoomTemplateIn;
procedure AltarRoomTemplateOut;

implementation

uses uImgTables, uGlobals, uRect, uMacTypes, uPop2Types, uRoomUtil, uPieces, uCellUtil,
uShapesets, uColorTables;

const

lastback: array[1..3] of array [0..2] of smallint = (
($75, $41, -$56),
($74, $28, -$56),
($76, $50, -$19)
);
loosemaskodd: array [0..11] of word = (0,1,0,2,2,0,0,0,1,1,1,0);
loosemaskeven: array [0..11] of word = (0,2,2,0,1,1,0,2,2,2,0,1);
torchrect: TMacRect = (top:$6; left:$2A; bottom:$30; right:$59);


procedure DrawBackWall;
var
backimg: word;
backmask: word;
backoffset: word;
previtem: PBFImgEntry;
d4: word;
rect: TMacRect;
oldrect: TMacRect;
topcell: smallint;
oldfore: word;
begin
backimg := NextBFItem^.PartBack.Back2;
backmask := backimg and $F00;
backmask := backmask shr 8;
backimg := backimg and $1F;
if backimg = 0 then exit;
if backimg = 20 then
begin
  backimg := 19;
  backoffset := 1;
end
else
  backoffset := 0;

if not drawingfull then
begin
  previtem := GetBackTableImgRow(backimg, NextBFItem^.PartCol-1, NextBFItem^.PartRow);
  if (previtem<>nil) and SectRect(previtem^.ClippedRect, drawingrect, rect) then
  begin
    d4:= 0;
    UnionRect(previtem^.ClippedRect, previtem^.ClippedRect, drawingrect);
    previtem := GetBackTableImgRow(backimg+1, NextBFItem^.PartCol - 1, NextBFItem^.PartRow);
    if (previtem <> nil) and SectRect(previtem^.ClippedRect, drawingrect, rect) then
    begin
      UnionRect(previtem^.ClippedRect, previtem^.ClippedRect, drawingrect);
    end;
  end
  else
  begin
    previtem := nil;
    d4 := 1;
  end;
end
else
begin
  previtem := nil;
  d4 := 0;
end;
if (previtem<>nil) then exit;
if (d4 = 0) and (backmask <> 0) and ((NextBFItem^.PartCol <> -1) or (backmask > 3)) and (NextBFItem^.PartRow<>3) then exit;
d4 := 1;
oldrect := drawingrect;
topcell := (NextBFItem^.partrow*120+5);
if (NextBFItem^.partrow >= 0) and
(NextBFItem^.row >= 0) and
not VisibleAbovePiece(NextBFItem^.partcol, NextBFItem^.partrow) and (drawingrect.top < topcell) then
begin
  if oldrect.top > topcell then
    drawingrect.top := oldrect.top
  else
    drawingrect.top := topcell;
  if EmptyRect(drawingrect) then
    d4 := 0;
end;
  if d4=1 then
  begin
    oldfore := NextBFItem^.partfore;
    NextBFItem^.partfore := CELL_EMPTY;
    NextBFItem^.transparent := 0;
    NextBFItem^.itemid := backimg;
    inc(backmask,36);
    DrawPiecePos(0, backmask);
      if AddNextBFItemToTable then
        ResetNextBFItemWithPrevInfo(0);
    if backoffset <> 0 then
    begin
      NextBFItem^.itemid := 20;
      NextBFItem^.left := 63;
      NextBFItem^.top := -37;
      if AddNextBFItemToTable then
        ResetNextBFItemWithPrevInfo(0);
    end
    else
    begin
      d4 := (NextBFItem^.PartBack.Back1 and $3000) shr 12;
      if d4 <> 0 then
      begin
        NextBFItem^.itemid := lastback[d4][0];
        NextBFItem^.left := lastback[d4][1];
        NextBFItem^.Top := lastback[d4][2];
        if AddNextBFItemToTable then
          ResetNextBFItemWithPrevInfo(0);
      end;
    end;
    NextBFItem^.PartFore := oldfore;
    NextBFItem^.transparent := $10;
  end;
  drawingrect := oldrect;

end;

procedure DrawEmpty;
var
candraw: boolean;
begin
if NextBFItem^.Layer <> 0 then exit;
candraw := false;
if drawingrow = NextBFItem^.partrow then
  candraw := true
else if NextBFItem^.PartRow = (drawingrow+1) then
  candraw := VisibleAbovePiece(NextBFItem^.PartCol, NextBFItem^.PartRow);
if not candraw and (drawingrow = -1) and isspace(os_fore) then
  candraw := true;

if candraw then
  DrawBackWall;

end;

procedure DrawFloor;
var
layer: word;
begin
  case NextBFItem^.Layer of
  0: DrawBackWall;
  1: begin
    NextBFItem^.Transparent := 0;
    NextBFItem^.ItemID := (NextBFItem^.partback.back1 and 1) + $1D;
    DrawPiecePos(1, CELL_FLOOR);
    if not AddNextBFItemToTable then
      NextBFItem^.transparent := $10;
  end;
  2,5: begin
    layer := NextBFItem^.layer;
    NextBFItem^.ItemID := $1C;
    DrawPiecePos(-1, CELL_FLOOR);
    if AddNextBFItemTOTable then
      ResetNextBFItemWithPrevInfo(layer);
    if (NextBFItem^.PartBack.Back1 and 2) <> 0 then
      DrawEdge;
  end;
  end;
end;

procedure DrawEdge;
var
layer: word;
begin
  layer := NextBFItem^.layer;
  if not (layer in [2,5]) then exit;
  if (custompieces<>nil) and (custompieces^.ID=$1F) then
  begin
    NextBFItem^.ItemID := $77;
    NextBFItem^.left := $04;
    NextBFItem^.Top := -$14;
    if NextBFItem^.PartCol <> 1 then
      inc(NextBFItem^.Left, 3);
  end
  else
  begin
    NextBFItem^.ItemID := $5E;
    NextBFItem^.left := $22;
    NextBFItem^.Top := -$17;
  end;
    if AddNextBFItemTOTable then
      ResetNextBFItemWithPrevInfo(layer);

    if (NextBFItem^.PartBack.back1 and 1) <> 0 then
    begin
    NextBFItem^.ItemID := $5E;
    NextBFItem^.left := $22;
    NextBFItem^.Top := -$19;
    if AddNextBFItemTOTable then
      ResetNextBFItemWithPrevInfo(layer);

    end;
end;

procedure DrawSpikes;
begin
  case NextBFItem^.layer of
  1: begin
    NextBFItem^.PartBack.Back1 := NextBFItem^.PartBack.Back1 and $FFFC;
    DrawWall;
  end;
  5: begin
    if NextBFItem^.PartCol = 9 then exit;
    NextBFItem^.PartBack.Back1 := NextBFItem^.PartBack.Back1 and $FFFC;
    DrawWall;
    if NextBFItem=nil then
      ResetNextBFItemWIthPrevInfo(5);
    DrawPiece;
    AddNextBFItemToTable
  end;
  end;
end;

procedure DrawPosts;
begin
  case NextBFItem^.layer of
  0: DrawBackWall;
  1: begin
    DrawPiece;
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(1);
    DrawFloor;
  end;
  2,5: begin
    DrawPiece;
    AddNextBFItemToTable;
  end;
  end;
end;

procedure DrawGate;
var
layer: word;
begin
  layer := NextBFItem^.layer;
  case layer of
  0: DrawBackWall;
  1: begin
    DrawPiece;
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(1);
    DrawFloor;
  end;
  2,5: begin
    DrawPiece;
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(layer);
    DrawGateMovable;
  end;
  
  end;

end;

procedure DrawGateMovable;
var
oldrect: TMacRect;
gamerect: TMacRect;
backmasked: word;
layer: word;
begin
  if not NextBFItem^.Layer in [2,5] then exit;
  oldrect := drawingrect;
  gamerect := backbuffer.rect;
  gamerect.top := NextBFItem^.PartRow * 120 - $13;
  if SectRect(gamerect, drawingrect, drawingrect) then
  begin
    backmasked := (NextBFItem^.partback.back1 and $FF) shr 1;
    if backmasked > $5C then
      backmasked := $5C;
    NextBFItem^.ItemID := GetPieceValue($454);
    NextBFItem^.Left := GetPieceValue($456);
    NextBFItem^.Top := -10 - backmasked;
    layer := NextBFItem^.layer;
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(layer);

  end;
  drawingrect := oldrect; 

end;

procedure DrawUpPlate;
var
pieceindex: word;
begin
  if (NextBFItem^.PartBack.Back1 and $2000) <> 0 then
    pieceindex := 6
  else
    pieceindex := 5;
  case NextBFItem^.layer of
  0: begin
    NextBFItem^.PartBack.back1 := NextBFItem^.PartBack.back1 and $DFFF;
    DrawBackWall;
  end;
  1: begin
    NextBFItem^.Transparent := 0;
    NextBFItem^.ItemID := 43;
    DrawPiecePos(-1, pieceindex);
    if not AddNextBFItemToTable then
      NextBFItem^.Transparent := $10;
  end;
  2,5: begin
    NextBFItem^.ItemID := 41;
    DrawPiecePos(-1, pieceindex);
    AddNextBFItemToTable;
  end;

  end;
end;

procedure DrawDownPlate;
var
pieceindex: word;
begin
if (NextBFItem^.PartBack.Back1 and $2000) <> 0 then
  pieceindex := 6
else
  pieceindex := 5;
  case NextBFItem^.layer of
  0: begin
    NextBFItem^.PartBack.back1 := NextBFItem^.PartBack.back1 and $DFFF;
    DrawBackWall;
  end;
  1: begin
    NextBFItem^.Transparent := 0;
    NextBFItem^.ItemID := 44;
    DrawPiecePos(-1, pieceindex);
    if not AddNextBFItemToTable then
      NextBFItem^.Transparent := $10;
  end;
  2,5: begin
    NextBFItem^.ItemID := 42;
    DrawPiecePos(-1, pieceindex);
    AddNextBFItemToTable;
  end;

  end;
end;

procedure DrawPillarBottom;
begin
  case NextBFItem^.layer of
  0: DrawBackWall;
  1: begin
    DrawPiece;
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(1);
    DrawFloor;
  end;
  2,5: begin
    DrawPiece;
    AddNextBFItemToTable;
  end;
  end;

end;

procedure DrawPillarTop;
var
backmasked: word;
begin
backmasked := NextBFItem^.PartBack.Back1 and 3;
case NextBFItem^.layer of
0: DrawBackWall;
1: begin
  if backmasked = 0 then
    DrawPiece
  else
  begin
    NextBFItem^.ItemID := backmasked + $23;
    if backmasked = 2 then
    begin
      NextBFItem^.Left := 0;
      NextBFItem^.Top := 0;
    end
    else
    begin
      NextBFItem^.Left := 0;
      NextBFItem^.Top := -11;
    end;
  end;
  AddNextBFItemToTable;
end;
5: begin
if backmasked = 0 then
begin
  DrawPiece;
  AddNextBFItemToTable;
end;
end;
end;


end;

procedure DrawLoose;
var
candraw: boolean;
backmasked: word;
layer: word;
begin
  candraw := false;
  backmasked := NextBFItem^.PartBack.Back1 and $F;
  if backmasked <> 13 then
  begin
    if (NextBFItem^.PartCol and 1) = 1 then
      backmasked := loosemaskodd[backmasked]
    else
      backmasked := loosemaskeven[backmasked];
  end;
  case NextBFItem^.Layer of
  0: DrawBackWall;
  1: begin
    if backmasked <> 13 then
    begin
      if backmasked <> 0 then
      begin
        NextBFItem^.ItemID := 49 + backmasked;
        DrawPiecePos;
        AddNextBFItemToTable;
       end
      else
        candraw := true;
    end;
  end;
  2,5: begin
    if backmasked <> 13 then
    begin
      if backmasked <> 0 then
      begin
        NextBFItem^.ItemID := 44 + backmasked;
        DrawPiecePos;
        AddNextBFItemToTable
      end
      else
        candraw := true;
    end;
  end;
  end;
  if candraw then
  begin
    NextBFItem^.PartBack.Back1 := NextBFItem^.PartBack.Back1 and $FFF0;
    DrawFloor;
  end;
  

end;

procedure DrawRubble;
var
layer: word;
begin
  case NextBFItem^.layer of
  0: DrawBackWall;
  2,5: begin
    layer := NextBFItem^.layer;
    if (NextBFItem^.partback.back1 and 2) <> 0 then
      DrawEdge;
    if NextBFItem = nil then
      ResetNextBFItemWIthPrevInfo(layer);
  end;
  end;
  DrawDebris;
end;

procedure DrawDebris;
begin
  case NextBFItem^.layer of
  1,2,5: begin
    DrawPiece(-1, CELL_DEBRIS);
    AddNextBFItemToTable;
  end;
  end;
end;

procedure DrawExit1;
begin
  case NextBFItem^.layer of
  0: if drawingfull then DrawBackWall;
  1,2,5: begin
    NextBFItem^.partback.back1 := NextBFItem^.partback.back1 and $FFFC;
    DrawFloor;
  end;
  end;
end;
procedure DrawExit2;
var
oldback: word;
layer: word;
previtem: PBFImgEntry;
begin
  oldback := NextBFItem^.partback.back1;
  layer := NextBFItem^.layer;
  case layer of
  0: begin
    if drawingfull then
      DrawBackWall;
    DrawPiece;
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(0);
    if currentroom = currentlevel.initialroom then
    begin
      NextBFItem^.ItemID := $52;
      NextBFItem^.Left := 8;
      NextBFItem^.Top := -$21;
      if AddNextBFItemToTable then
        ResetNextBFItemWithPrevInfo(0);

    end;
    NextBFItem^.partback.back1 := oldback;
    DrawExitMovable;
  end;
  1,2,5: begin
    NextBFItem^.partback.back1 := (oldback and $FFFC) or 1;
    DrawFloor;
    if layer=5 then
    begin
      if NextBFItem=nil then
        ResetNextBFItemWIthPrevInfo(5);
      if kid.posn in [$D9..$E2] then
      begin
        previtem := NextBFItem;
        ResetNextBFItem(1);
        TransferBFItemMidFields(previtem, NextBFItem);
      end;
      NextBFItem^.ItemID := GetPieceValue($47C);
      NextBFItem^.Left := GetPieceValue($47E);
      NextBFItem^.Top := GetPieceValue($480);
      AddNextBFItemToTable;

    end;
  end;
  end;
end;

procedure DrawExitMovable;
var
oldrect: TMacRect;
gamerect: TMacRect;
backmasked: word;
begin
  if NextBFItem^.layer <> 0 then exit;
  oldrect := drawingrect;
  gamerect := backbuffer.rect;
  gamerect.top := NextBFItem^.partrow * 120 - 10;
  if SectRect(gamerect, drawingrect, drawingrect) then
  begin
    backmasked := NextBFItem^.partback.back1 and $FF;
    if backmasked > $4D then
    backmasked := $4D;
    NextBFItem^.ItemID := GetPieceValue($476);
    NextBFItem^.Left := GetPieceValue($478);
    NextBFItem^.Top := -$22 - (backmasked + 1);
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(0);
  end;
  drawingrect := oldrect;
end;

procedure DrawTorch;
var
layer: word;
rect: TMacRect;
oldback: word;
begin
layer := NextBFItem^.layer;
case layer of
0: begin
  ComputeOffsetCellRect(rect, torchrect, NextBFItem^.partcol, NextBFItem^.partrow);
  if not EncloseRect(rect, drawingrect) then
  begin
    NextBFItem^.Transparent := 0;
    NextBFItem^.PartFore := 0;
    DrawPiece(-1, CELL_TORCH);
    if AddNextBFItemToTable then
      ResetNextBFItemWithPrevInfo(0);
    NextBFItem^.Transparent := $10;
    NextBFItem^.PartFore := $13;
  end;
  NextBFItem^.ItemID := $60 + (NextBFItem^.PartBack.Back1 and $F);
  DrawPiecePos(2, CELL_TORCH);
  AddNextBFItemToTable;
  
end;
1: DrawFloor;
2,5: begin
  oldback := NextBFItem^.partback.back1;
  NextBFItem^.PartBack.back1 := oldback and $FFFC;
  DrawFloor;
  if NextBFItem = nil then
    ResetNextBFItemWithPrevInfo(layer);
  NextBFItem^.partback.Back1 := oldback;
    DrawPiece(-1, CELL_TORCH);
  AddNextBFItemToTable;
end;
end;
if NextBFItem = nil then
  ResetNextBFItemWithPrevInfo(layer);
end;



procedure DrawWall;
var
layer: word;
backmasked: smallint;
truerow: smallint;
atleft: word;
below: word;
atright: word;
begin
layer := NextBFItem^.layer;
backmasked := NextBFItem^.partback.back1 and 3;
backmasked := backmasked + $16;
case layer of
1: begin
  if backmasked <= $17 then
    NextBFItem^.left := 0
  else if drawingfull then
    backmasked := -1
  else
  begin
    NextBFItem^.left := -51;
    dec(backmasked, 2);
  end;
  if backmasked <> -1 then
  begin
    NextBFItem^.itemid := backmasked;
    NextBFItem^.top := GetPieceValue($1A2);
    if AddNextBFItemTOTable then
      ResetNextBFItemWithPrevInfo(1);
  end;
  backmasked := NextBFItem^.partback.back1 and 3;
  backmasked := backmasked + $16;
  truerow := NextBFItem^.partrow;
  if truerow < 0 then
    inc(truerow, 3);
  atleft := PieceLeftID(NextBFItem^.partcol, truerow);
  if (backmasked <= $17) and not isspace(atleft) and (atleft<>CELL_LOOSE) and (atleft<>CELL_FLIP) then
  begin
    NextBFItem^.itemid := $18;
    DrawPiecePos(-1, CELL_WALL);
    if AddNextBFItemTOTable then
    begin
      ResetNextBFItemWithPrevInfo(1);
      NextBFItem^.transparent := $10;
    end;
  end;
  below := PieceBelowID(NextBFItem^.partcol, truerow);
  if not iswall(below) then exit;
  NextBFItem^.transparent := 0;
  if IsWall(atleft) then
    NextBFItem^.itemid := $1A
  else
    NextBFItem^.itemid := $19;
  DrawPiecePos(-1, CELL_WALL);
  if not AddNextBFItemToTable then
    NextBFItem^.transparent := $10;
end;
2,5: begin
  if backmasked = $17 then exit;
  atright := PieceRightID(NextBFItem^.partcol, NextBFItem^.partrow);
  if iswall(atright) then exit;
  NextBFItem^.itemid := $15;
  DrawPiecePos(-1, CELL_WALL);
  if AddNextBFItemToTable then
    ResetNextBFItemWithPrevInfo(layer);
  if (NextBFItem^.partback.back1 and 4) = 0 then exit;
  NextBFItem^.itemid := $1B;
  DrawPiecePos(-1, CELL_WALL);
  AddNextBFItemToTable;

end;
end;
end;

procedure DrawFlip;
var
backmasked: word;
begin
backmasked := NextBFItem^.partback.back1 and $1F;
NextBFItem^.partback.back1 := NextBFItem^.partback.back1 and $FFE0;
case NextBFItem^.layer of
0: if backmasked = 0 then DrawFloor else DrawBackWall;
1,2,5: if backmasked = 0 then DrawFloor;
end;
end;

procedure DrawTorchDebris;
begin
  DrawTorch;
  DrawDebris;
end;

procedure DrawFlame;
var
oldrect: TMacRect;
backmasked: word;
begin
  if NextBFItem^.layer <> 11 then exit;
  oldrect := drawingrect;
  drawingrect := backbuffer.rect;
  if (NextBFItem^.partback.back1 and $80) <> 0 then
  begin
    backmasked := NextBFItem^.partback.back1 and $FF7F;
    //petit skip.
  end
  else
  begin
    DrawCustomRoomImg(NextBFItem^.partback.back1+2, 11);
  end;
  drawingrect := oldrect;

end;

procedure AltarRoomTemplateIn;
begin
  LoadFlameShapes(1);
  PopSetPalette(4077, $E0);
  if Kid.Status = $D then
    PopSetPalette(2001, $30)
  else
    PopSetPalette(2000, $30);
end;

procedure AltarRoomTemplateOut;
begin
  UnloadFlameShapes;
  PopSetPalette(3000, $E0);
end;


end.


